<?PHP
/***************************************************************************\
*
*	Copyright (c) 2013 deltra Business Software GmbH & Co. KG
*	http://www.deltra.de
*
\***************************************************************************/

$GLOBALS['VERSION_SCF'] = "4.0.00";

function daten_holen()
{
	#Querytyp:

	// datakind == 1 => Daten werden als Query verarbeitet
	// datakind == 2 => Daten werden als Array verarbeitet

	$GLOBALS['datakind'] = "1";

	$artLanguage = $GLOBALS['articles_language'];
	$orderStatus = $GLOBALS["DEFAULT_ORDERS_STATUS"];

	// Get-Attributes-Query
	$attributes = "(
		select GROUP_CONCAT(properties_values_id ORDER BY products_properties_index.properties_id SEPARATOR '\\n-')
		from products_properties_index
		WHERE products_properties_index.`products_properties_combis_id` =
		(
			SELECT products_properties_combis_id
			FROM orders_products_properties
			WHERE orders_products_properties.`orders_products_id` = orders_products.`orders_products_id` LIMIT 1
		)
		AND products_properties_index.`language_id` = $artLanguage
	)";

	#SQL Query für Gambio
	$GLOBALS['query'] ="SELECT
			orders.orders_id as orderID,
			orders.orders_id as BestellnummerShop,
			orders.date_purchased as Bestelldatum,
			orders.shipping_class as Lieferart,
			orders.payment_class as Zahlungsart,
			SUM(orders_total.value) as FrachtkostenNetto,
			SUM(Coupon.value) as Coupon,
			orders.comments as AnmerkungenBestellung,
			orders.customers_id as KundennummerWebshop,
			orders.customers_company as Firmenname,
			orders.customers_lastname as PersonNachname,
			orders.customers_firstname as PersonVorname,
			orders.customers_street_address as Strasse,
			orders.customers_postcode as Postleitzahl,
			orders.customers_city as Ort,
			orders.customers_country as Land,
			orders.customers_email_address as Email,
			orders.customers_telephone as Telefon,
			orders.customers_vat_id as Umsatzsteueridentnummer,
			MIN(banktransfer.banktransfer_owner) as BankkontoInhaber,
			MIN(banktransfer.banktransfer_number) as Bankkontonummer,
			MIN(banktransfer.banktransfer_blz) as BankkontoBLZ,
			MIN(banktransfer.banktransfer_bankname) as BankkontoBankName,
			orders.delivery_company as abweichendLieferungFirmenname,
			orders.delivery_lastname as abweichendLieferungPersNachname,
			orders.delivery_firstname as abweichendLieferungPersVorname,
			orders.delivery_street_address as abweichendLieferungStrasse,
			orders.delivery_postcode as abweichendLieferungPostleitzahl,
			orders.delivery_city as abweichendLieferungOrt,
			orders.delivery_country_iso_code_2 as abweichendLieferungLaendercode,
			orders.delivery_country as abweichendLieferungLand,
			orders.billing_company as abweichendRechnungFirmenname,
			orders.billing_lastname as abweichendRechnungPersNachname,
			orders.billing_firstname as abweichendRechnungPersVorname,
			orders.billing_street_address as abweichendRechnungStrasse,
			orders.billing_postcode as abweichendRechnungPostleitzahl,
			orders.billing_city as abweichendRechnungOrt,
			orders.billing_country_iso_code_2 as abweichendRechnungLaendercode,
			orders.billing_country as abweichendRechnungLand,
			customers_status.customers_status_show_price_tax as xBrutto,
			orders_products.orders_products_id as Positionsnummer,
			products.products_model as ArtikelnummerShop,
			orders_products.products_model as xArtikelnummerShop,
			orders_products.products_quantity as Menge,
			orders_products.products_price as abweichenderEinzelpreisNetto,
			orders_products.products_tax as abweichendeMwStProzent,
			MIN(orders_products_attributes.products_options) as xProduktOption,
			MIN(orders_products_attributes.products_options_values) as xProduktOptionsWert,
			$attributes as xProduktEigenschaften,
			orders_products.products_id as xProduktId
		FROM orders
		INNER JOIN
			orders_products ON (orders.`orders_id` = orders_products.`orders_id`)
		LEFT OUTER JOIN
			orders_products_attributes ON (`orders_products`.`orders_products_id` = orders_products_attributes.`orders_products_id`)
		LEFT OUTER JOIN
			orders_total ON (orders.`orders_id` = orders_total.`orders_id` AND orders_total.`class` = 'ot_shipping')
		LEFT OUTER JOIN
			products ON (products.`products_id` = orders_products.`products_id`)		  
		LEFT OUTER JOIN
			orders_total as Coupon ON (orders.`orders_id` = Coupon.`orders_id` AND Coupon.`class` = 'ot_coupon')
		LEFT OUTER JOIN
			banktransfer ON (orders.`orders_id` = `banktransfer`.`orders_id`)
		LEFT OUTER JOIN
			customers_status ON (customers_status.`customers_status_id` = orders.`customers_status` AND customers_status.`language_id` = $artLanguage)
		WHERE
			orders_status = '$orderStatus'
		GROUP BY orders_products.orders_products_id
		ORDER BY orderID, Positionsnummer";
	return $GLOBALS['datakind'];
}

function row_ueberpruefen($row)
{
	# Anschrift überarbeiten
	$row['Firmenname'] = htmlspecialchars($row['Firmenname']);
	$row['PersonNachname'] = htmlspecialchars($row['PersonNachname']);
	$row['PersonVorname'] = htmlspecialchars($row['PersonVorname']);
	$row['Strasse'] = htmlspecialchars($row['Strasse']);
	$row['Ort'] = htmlspecialchars($row['Ort']);
	$row['Land'] = htmlspecialchars($row['Land']);
	$row['Email'] = htmlspecialchars($row['Email']);
	$row['ArtikelnummerShop'] = htmlspecialchars($row['ArtikelnummerShop']);
	$row['AnmerkungenBestellung'] = htmlspecialchars($row['AnmerkungenBestellung']);
	
	# abeichende Rechnungsadresse
	$row['abweichendRechnungFirmenname'] = htmlspecialchars($row['abweichendRechnungFirmenname']);
	$row['abweichendRechnungPersNachname'] = htmlspecialchars($row['abweichendRechnungPersNachname']);
	$row['abweichendRechnungPersVorname'] = htmlspecialchars($row['abweichendRechnungPersVorname']);
	$row['abweichendRechnungStrasse'] = htmlspecialchars($row['abweichendRechnungStrasse']);
	$row['abweichendRechnungOrt'] = htmlspecialchars($row['abweichendRechnungOrt']);
	$row['abweichendRechnungLand'] = utf8_encode(htmlspecialchars($row['abweichendRechnungLand']));
	
	# abweichende Lieferadresse
	$row['abweichendLieferungFirmenname'] = htmlspecialchars($row['abweichendLieferungFirmenname']);
	$row['abweichendLieferungPersNachname'] = htmlspecialchars($row['abweichendLieferungPersNachname']);
	$row['abweichendLieferungPersVorname'] = htmlspecialchars($row['abweichendLieferungPersVorname']);
	$row['abweichendLieferungStrasse'] = htmlspecialchars($row['abweichendLieferungStrasse']);
	$row['abweichendLieferungOrt'] = htmlspecialchars($row['abweichendLieferungOrt']);
	$row['abweichendLieferungLand'] = utf8_encode(htmlspecialchars($row['abweichendLieferungLand']));

	# Strasse anpassen (für v3.1.x.x)
	$row['Strasse'] .= getHouseNumber($row['orderID'], "customers_house_number");
	$row['abweichendLieferungStrasse'] .= getHouseNumber($row['orderID'], "delivery_house_number");
	$row['abweichendRechnungStrasse'] .= getHouseNumber($row['orderID'], "billing_house_number");
	
	# Geschlecht ermitteln
	$row['PersonGeschlecht'] = '';
	$query = "Select customers_gender AS Geschlecht ";
	$query .= "FROM customers ";
	$query .= "WHERE customers_id = ".$row['KundennummerWebshop']."";
	$qRes = mysqli_query($GLOBALS['sql_con'], $query);

	if ($qRes)
	{
		$qRow = mysqli_fetch_assoc($qRes);
		$row['PersonGeschlecht'] = $qRow['Geschlecht'];
	}// Das Geschlecht-Ermittlungsquery wurde erfolgreich ausgeführt

	# Anrede ergänzen:
	$row['PersonAnrede'] = '';
	if (($row["PersonAnrede"]=="") and (strtolower($row["PersonGeschlecht"])=="m"))
	{
		$row["PersonAnrede"] = "Herr";
	}// Wenn keine Anrede hinterlegt ist und das Geschlecht männlich
	elseif (($row["PersonAnrede"]=="") and ((strtolower($row["PersonGeschlecht"])=="w") or ((strtolower($row["PersonGeschlecht"])=="f"))))
	{
		$row["PersonAnrede"] = "Frau";
	}// Wenn keine Anrede hinterlegt ist und das Geschlecht weiblich

	# Laender korrigieren...

	// ... Adresse
	if ((strtolower($row["Land"]) == "germany")) {$row["Land"] = "Deutschland";}
	if ((strtolower($row["Land"]) == "austria")) {$row["Land"] = "Österreich";}
	if ((strtolower($row["Land"]) == "switzerland")){$row["Land"] = "Schweiz";}

	// ... Lieferadresse
	if ((strtolower($row["abweichendLieferungLand"]) == "germany"))	{$row["abweichendLieferungLand"] = "Deutschland";}
	if ((strtolower($row["abweichendLieferungLand"]) == "austria")) {$row["abweichendLieferungLand"] = "Österreich";}
	if ((strtolower($row["abweichendLieferungLand"]) == "switzerland")) {$row["abweichendLieferungLand"] = "Schweiz";}

	// ... Rechnungsadresse
	if ((strtolower($row["abweichendRechnungLand"]) == "germany")) {$row["abweichendRechnungLand"] = "Deutschland";}
	if ((strtolower($row["abweichendRechnungLand"]) == "austria")) {$row["abweichendRechnungLand"] = "Österreich";}
	if ((strtolower($row["abweichendRechnungLand"]) == "switzerland")) {$row["abweichendRechnungLand"] = "Schweiz";}
	
	// ... ISO Länderkürzel in orgaMAX Format übersetzen
	$row['Laendercode'] = (isset($row['Laendercode'])) ? LaenderkuerzelISO2OMX($row['Laendercode']) : '';	
	$row['abweichendRechnungLaendercode'] = LaenderkuerzelISO2OMX($row['abweichendRechnungLaendercode']);
	$row['abweichendLieferungLaendercode'] = LaenderkuerzelISO2OMX($row['abweichendLieferungLaendercode']);

	# Ggf Produktattribute berücksichtigen
	switch ($GLOBALS['attributes_import'])
	{
		case 1:
			if (!empty($row['xProduktOptionsWert'])) $row['ArtikelnummerShop'] .= "-" . $row['xProduktOptionsWert'];
			break;
		case 2:
			if (!empty($row['xProduktEigenschaften'])) $row['ArtikelnummerShop'] .= "\n- " . $row['xProduktEigenschaften'];
			break;
		case 3:
			if (!empty($row['xArtikelnummerShop'])) $row['ArtikelnummerShop'] = $row['xArtikelnummerShop'];
			break;
	}
	
	# Nachnamegebühren ermitteln
	if (strtolower($row['Zahlungsart']) == 'cod')
	{
		$query = "SELECT value ";
		$query .= "FROM orders_total ";
		$query .= "WHERE (orders_id=" . $row['orderID'] . ") and (class='ot_cod_fee')";
		$qRes = mysqli_query($GLOBALS['sql_con'], $query);
		if ($qRes)
		{
			$qRow = mysqli_fetch_assoc($qRes);
			$row['ZuschlagkostenBrutto1'] = $qRow['value'];
		} // Das Nachnahmegebür ermittlungsquery wurde erfolgreich ausgeführt
	} // Es ist ein Nachname Zahlung

    # SEPA-Informationen ermitteln
    if (hasSepaPlugin())
    {
        $query = "SELECT
                    sepa_owner as SepaInhaber,
                    sepa_iban as SepaIban,
                    sepa_bic as SepaBic,
                    sepa_bankname as SepaBankName,
                    sepa_status as SepaStatus
                  FROM
                    sepa
                  WHERE
                    orders_id = " . $row["BestellnummerShop"];
        $qRes = mysqli_query($GLOBALS['sql_con'], $query);

        if ($qRes)
        {
            $qRow = mysqli_fetch_assoc($qRes);
            $row["SepaInhaber"] = $qRow["SepaInhaber"];
            $row["SepaBankName"] = $qRow["SepaBankName"];
            $row["SepaIban"] = $qRow["SepaIban"];
            $row["SepaBic"] = $qRow["SepaBic"];
            $row["SepaStatus"] = $qRow["SepaStatus"];
        }
    }

	# Zahlungsart "übersetzen"
	if ($row["Zahlungsart"])
	{
		if (($row["Zahlungsart"] == "sepa")) // vllt noch $row["SepaStatus"] berücksichtigen???
		{
			$row["BankkontoInhaber"] = $row["SepaInhaber"];
			$row["BankkontoBankName"] = $row["SepaBankName"];
			$row["BankkontoIBAN"] = $row["SepaIban"];
			$row["BankkontoBIC"] = $row["SepaBic"];
		}
        $zahlungsart = 'ORGAMAX_OS_ZAHLUNGSART_' . strtoupper($row['Zahlungsart']);
		$row['Zahlungsart'] = (DeltraResources::isResource($zahlungsart)) ? DeltraResources::getText($zahlungsart) : $row["Zahlungsart"];
	}
	
	# Frachtkosteneinstellungen
	$shipping_class = explode('_', $row['Lieferart']);
	$row['Lieferart'] = $shipping_class[0];
	$row['FrachtkostenBrutto'] = '';
	
	#Frachtkosten bestimmen
	$query = "Select gx_configurations.value, ";
	$query .= "tax_rates.tax_rate as FrachtkostenMwStProzent ";
	$query .= "FROM gx_configurations ";
	$query .= "INNER JOIN tax_rates ON (gx_configurations.value  = tax_rates.tax_rates_id) ";
	$query .= "WHERE `key` = 'configuration/MODULE_SHIPPING_".strtoupper($row['Lieferart'])."_TAX_CLASS'";
	$qRes = mysqli_query($GLOBALS['sql_con'], $query);

	if ($qRes)
	{
		$qRow = mysqli_fetch_assoc($qRes);
		$row['FrachtkostenMwStProzent'] = $qRow['FrachtkostenMwStProzent'];
	}// MwSt.-Ermittlungsquery wurde erfolgreich ausgeführt
	else
	{
		$row['FrachtkostenMwStProzent'] = "";
	}
	
	# Preisartbestimmung:
	if ($row['xBrutto'])
	{
		$row['FrachtkostenBrutto'] = $row['FrachtkostenNetto'];
		$row['abweichenderEinzelpreisBrutto'] = $row['abweichenderEinzelpreisNetto'];
		// Netto Kosten leer setzen, damit erkannt wird dass es ein Brutto Vorgang ist
		$row['FrachtkostenNetto'] = '';
		$row['abweichenderEinzelpreisNetto'] = '';
	} // Wenn eine UStId vergeben ist, übergibt xtcommerce Nettopreise statt wie sonst üblich Bruttopreise
	else
	{
		// $row['abweichenderEinzelpreisBrutto'] = $row["abweichenderEinzelpreisNetto"] * ( 1 + ($row['abweichendeMwStProzent'] / 100));
		// $row['FrachtkostenBrutto'] = $row['FrachtkostenNetto'] * (1 + ($row['FrachtkostenMwStProzent'] / 100));
		$row['abweichenderEinzelpreisBrutto'] = '';
		$row['FrachtkostenBrutto'] = '';
	}
	
	$row['ZuschlagkostenBrutto1'] += $row['Coupon'] * -1;
	// $row['ZuschlagkostenBrutto2'] = $row['Coupon'] * -1;

	// MR: 28.09.2012
	// Anpassung der Lieferart direkt ins Array geschrieben, da vorherige Implementierung einen fehlerhaften String zurück gab.
	$row["Lieferart"] = 'ORGAMAX_OS_LIEFERART_' . strtoupper($row['Lieferart']);
	
	# Artikelnummer-Einstellungen:
	if ($GLOBALS["artno_handling"] == 1)
	{
		$row['Artikelnummer'] = $row['ArtikelnummerShop'];
	} // 'Artikelnummer im Webshop' ist identisch zur Artikelnummer in orgaMAX
	
	# Prüfen ob Bestellung MwSt frei ist
	$query =  "SELECT orders_total_id ";
	$query .= "FROM orders_total ";
	$query .= "WHERE class = 'ot_tax' AND orders_id = ".$row["BestellnummerShop"]."";
	$qRes = mysqli_query($GLOBALS['sql_con'], $query);
	
	if(mysqli_num_rows($qRes) == false)
	{
		$row['abweichendeMwStProzent'] = '0.00';
	}
	
	# MwStProzent
	if ($row['abweichendeMwStProzent'] == '')
	{
		$row['abweichendeMwStProzent'] = '0.00';
	}

	return $row;
}

function artikeldaten_orgamax_zu_shop()
{
	$articleFile = file_get_contents('php://input');
	if($articleFile != null && strlen($articleFile) > 0) {
	
		$articles = simplexml_load_string(($articleFile));
		$amount_successfully_created = 0;
		$amount_articles = $articles->count();
		
		foreach($articles as $article)
		{
			$Preis = 0.0;
			$Gewicht = 0.0;
			$articleNr =  $article->ArtikelnummerWebshop;
			
			// Artikelpreis formatieren
			if($article->ArtikelpreisNetto != 'DSC_IGNORE')
			{
				$Preis = str_replace(',','.',$article->ArtikelpreisNetto);
			}
			else
			{
				$Preis = str_replace(',','.',$article->ArtikelpreisBrutto);
			}
			
			//Artikelgewicht formatieren
			if(!is_null($article->Gewicht))
			{
				$Gewicht = str_replace(',','.',$article->Gewicht);
			}
			
			//Prüfen ob der Artikel vorhanden ist
			$selectQuery = "SELECT products_id FROM products WHERE products_model = '".$articleNr."'";
			
			$res = mysqli_query($GLOBALS['sql_con'], $selectQuery);
			$amount = mysqli_num_rows($res);
			$value = 0;
			if($amount > 0)
			{
				$value = mysqli_result($res);
			}
			
			// MwStCode aus MwStValue ermitteln
			$query = "SELECT tax_class_id FROM tax_rates WHERE tax_rate = ".$article->MwStValue;
			$result = mysqli_query($GLOBALS['sql_con'], $query);
			if(mysqli_num_rows($result) > 0)
			{
				$MwStCode = ($article->MwStValue != 0) ? mysqli_result($result) : 0;
				$article->MwStCode = $MwStCode;
			}
			
			$Artikelbeschreibung = mysqli_escape_string($GLOBALS['sql_con'], strval($article->Artikelbeschreibung));
			$Anmerkungen = mysqli_escape_string($GLOBALS['sql_con'], strval($article->Anmerkungen));
			//Artikel nicht gefunden, neu anlegen
			if($value == 0)
			{
				$query  = "INSERT INTO products(products_model,products_tax_class_id,products_weight, products_price) ";
				$query .= "VALUES('".mysqli_escape_string($GLOBALS['sql_con'], $articleNr)."',".$article->MwStCode.",'".$Gewicht."','".$Preis."')";
				
				mysqli_query($GLOBALS['sql_con'], $query);
				
				$selectQuery = "SELECT products_id FROM products WHERE products_model = '".$articleNr."'";
			
				$res = mysqli_query($GLOBALS['sql_con'], $selectQuery);
				
				$value = mysqli_result($res);
				
				//Kategorie ebene 0 hinzufügen (keine Kategorie)
				$insertCat = "INSERT INTO products_to_categories(products_id, categories_id) VALUES(".intval($value).",0)";
				
				$result = mysqli_query($GLOBALS['sql_con'], $insertCat);

				if (!$result) continue;
				
				$descQuery = "INSERT INTO products_description(products_id, products_name, products_description, language_id, products_meta_title, products_meta_description, products_meta_keywords, checkout_information) ";
				$descQuery .= "VALUES(".intval($value).", '".mysqli_escape_string($GLOBALS['sql_con'], $Artikelbeschreibung)."', '".mysqli_escape_string($GLOBALS['sql_con'], $Anmerkungen)."', ".$GLOBALS['articles_language'].", '', '', '', '')";
				
				$result = mysqli_query($GLOBALS['sql_con'], $descQuery);
				
				if (!$result) continue;

				$amount_successfully_created++;
			}
			//Artikel vorhanden aktualisieren
			else
			{
				$query  = "UPDATE products SET products_model = '".$articleNr."', products_tax_class_id = ".$article->MwStCode.", ";
				$query .= "products_weight = '".$Gewicht."', products_price = '".$Preis."' WHERE products_id = ".$value."";
				
				$result = mysqli_query($GLOBALS['sql_con'], $query);

				if (!$result) continue;
				
				$descQuery 	= "UPDATE products_description SET products_name = '".mysqli_escape_string($GLOBALS['sql_con'], $Artikelbeschreibung)."', products_description = '".mysqli_escape_string($GLOBALS['sql_con'], $Anmerkungen)."'";
				$descQuery .= " WHERE products_id = ".$value."";
				
				$result = mysqli_query($GLOBALS['sql_con'], $descQuery);
				
				if (!$result) continue;

				$amount_successfully_created++;
			}
		}
		
		WriteXMLResult($amount_articles, $amount_successfully_created);
	}
}

function setze_lagerbestand_im_shop()
{
	$articleFile = file_get_contents('php://input');
	$amount_successfully_created = 0;
	$amount_articles = 0;
	if($articleFile != null && strlen($articleFile) > 0)
	{
		$articles = simplexml_load_string(($articleFile));
		
		$amount_articles = $articles->count();

		// Attribute-Varianten vorberechnen
		$attributes = getPreCalculateAttributes();
		
		foreach($articles as $article)
		{
			$articleNr = (string)$article->ArtikelnummerWebshop;
			$stock = str_replace(',', '.', $article->LagerBestandAktuell);
			$query = "UPDATE products SET products_quantity = '" . $stock . "'";
			$query .= " WHERE products_model = '" . mysqli_real_escape_string($GLOBALS['sql_con'], $articleNr) . "'";

			$result = mysqli_query($GLOBALS['sql_con'], $query);

			switch ($GLOBALS['attributes_import'])
			{
				case 1:
					foreach ($attributes as $attribute)
					{
						if ($attribute["AttributeName"] == $articleNr)
						{
							$query = "UPDATE products_attributes SET attributes_stock = '" . $stock . "'";
							$query .= " WHERE products_attributes_id = " . $attribute["AttributeId"];

							$result = mysqli_query($GLOBALS['sql_con'], $query);
						}
					}
					break;
				case 2:
					$query = "
							SELECT combis.Id
							FROM
								(SELECT
									ppi.products_properties_combis_id as Id,
									CONCAT(p.products_model, '-', GROUP_CONCAT(ppi.properties_values_id ORDER BY ppi.properties_id SEPARATOR '-')) as product_combination_id
								FROM products p
								LEFT JOIN
									products_properties_index ppi ON (ppi.products_id = p.products_id AND ppi.language_id = " . $GLOBALS['articles_language'] . ")
								GROUP BY
									ppi.products_properties_combis_id
								ORDER BY
									p.products_id) as combis
							WHERE
								combis.product_combination_id = '$articleNr'";
					$combiId = mysqli_scalar($GLOBALS['sql_con'], $query);
					if ($combiId)
					{
						$query = "UPDATE products_properties_combis SET combi_quantity = $stock WHERE products_properties_combis_id = $combiId";
						$result = mysqli_query($GLOBALS['sql_con'], $query);
					}
					break;
				case 3:
					$query = "
							SELECT combis.Id
							FROM
							(
								SELECT
									ppc.products_properties_combis_id as Id,
									CONCAT(p.products_model, '-', ppc.combi_model) as sku
								FROM products_properties_combis ppc
								INNER JOIN products p
								ON (p.products_id = ppc.products_id)
							) as combis
							WHERE combis.sku = '$articleNr'";
					$combiId = mysqli_scalar($GLOBALS['sql_con'], $query);
					if ($combiId)
					{
						$query = "UPDATE products_properties_combis SET combi_quantity = $stock WHERE products_properties_combis_id = $combiId";
						$result = mysqli_query($GLOBALS['sql_con'], $query);
					}
					break;
			}

			if ($result) $amount_successfully_created++;
		}
	}

	WriteXMLResult($amount_articles,$amount_successfully_created);
	//Hier können Sie den Bestellstatusexport vom ERP zum Shop definieren
}

function pruefeOffeneBestellungenImShop()
{
	$query = "SELECT orders.orders_id FROM orders, orders_total WHERE orders_status = '".$GLOBALS["DEFAULT_ORDERS_STATUS"]."'";
	
	$result = mysqli_query($GLOBALS['sql_con'], $query);
	
	if($result)
	{
		if(mysqli_num_rows($result) > 0)
		{
			$value = mysqli_result($result);
			if($value > 0)
			{
				echo 1;
			}
			else
			{
				echo 0;
			}
		}
		else
		{
			echo 0;
		}
	}
	else
	{
		echo 0;
	}
}

function hole_Artikelliste_fuer_export()
{
	$selectQuery = "";

	switch ($GLOBALS['attributes_import'])
	{
		case 1:
			$selectQuery = "
				SELECT
					products.products_model,
					products_description.products_name,
					products_options_values.products_options_values_name AS Var_Wert
				FROM products
				INNER JOIN
					products_description ON (products.products_id = products_description.products_id AND products_description.language_id = ".$GLOBALS['articles_language'].")
				LEFT OUTER JOIN
					products_attributes ON (products.products_id = products_attributes.products_id)
				LEFT OUTER JOIN
					products_options ON (products_attributes.options_id = products_options.products_options_id AND products_options.language_id = ".$GLOBALS['articles_language'].")
				LEFT OUTER JOIN
					products_options_values ON (products_attributes.options_values_id = products_options_values.products_options_values_id AND products_options_values.language_id = ".$GLOBALS['articles_language'].")
				ORDER BY
					products.products_id";
			break;
		case 2:
			$selectQuery = "
				SELECT
					products.products_model,
					products_description.products_name,
					GROUP_CONCAT(products_properties_index.properties_values_id ORDER BY products_properties_index.properties_id SEPARATOR '-') as xProduktEigenschaften
				FROM products
				INNER JOIN
					products_description ON (products.products_id = products_description.products_id AND products_description.language_id = ".$GLOBALS['articles_language'].")
				LEFT JOIN
					products_properties_index ON (products_properties_index.products_id = products.products_id AND products_properties_index.language_id = ".$GLOBALS['articles_language'].")
				GROUP BY
					products.products_id, products_properties_index.products_properties_combis_id
				ORDER BY
					products.products_id";
			break;
		case 3:
			$selectQuery = "
				SELECT
					products.products_model,
					products_description.products_name,
					products_properties_combis.combi_model AS xCombiModel
				FROM products
				INNER JOIN
					products_description ON (products_description.products_id = products.products_id AND products_description.language_id = ".$GLOBALS['articles_language'].")
				LEFT JOIN
					products_properties_combis ON (products_properties_combis.products_id = products.products_id)";
			break;
		default:
			$selectQuery = "
				SELECT
					products.products_model,
					products_description.products_name
				FROM products
				INNER JOIN
					products_description ON (products.products_id = products_description.products_id AND products_description.language_id = ".$GLOBALS['articles_language'].")
				ORDER BY
					products.products_id";
			break;
	}
	
	/** XML-Dokument erzeugen */
	$dom = new DomDocument('1.0');
	$dom->xmlStandalone = true;
	$dom->encoding="utf-8";
	
    $domArticles = $dom->appendChild($dom->createElement('ArtikelListeWebshop'));
	$result = mysqli_query($GLOBALS['sql_con'], $selectQuery);
	
	if(mysqli_num_rows($result) > 0)
	{
		while($article = mysqli_fetch_assoc($result))
		{
			switch ($GLOBALS['attributes_import'])
			{
				case 1:
					if (!empty($article["Var_Wert"])) $article["products_model"] .= "-" . $article["Var_Wert"];
					break;
				case 2:
					if (!empty($article["xProduktEigenschaften"])) $article["products_model"] .= "-" . $article["xProduktEigenschaften"];
					break;
				case 3:
					if (!empty($article["xCombiModel"])) $article["products_model"] .= "-" . $article["xCombiModel"];
					break;
			}

			$domArticle = $domArticles->appendChild($dom->createElement('row'));
			Add_NewDocElement($dom, $domArticle, 'ArtikelnummerWebshop', $article["products_model"]);
			Add_NewDocElement($dom, $domArticle, 'Artikelbeschreibung', $article["products_name"]);
		}
	}
	
	 $dom->formatOutput = true;
	 //zurück geben
     echo $dom->saveXML();
}

function setze_Artikelpreise_im_shop()
{
	$articleFile = file_get_contents('php://input');
	if($articleFile != null && strlen($articleFile) > 0) {
	
		$articles = simplexml_load_string(($articleFile));
		
		$amount_successfully_created = 0;
		$amount_articles = $articles->count();

		$attributes = getPreCalculateAttributes();
		
		foreach($articles as $article)
		{
			$Preis = 0.0;
			$articleNr = $article->ArtikelnummerWebshop;

			if($article->ArtikelpreisNetto != 'DSC_IGNORE')
			{
				$Preis = str_replace(',','.',$article->ArtikelpreisNetto);
			}
			else
			{
				$Preis = str_replace(',','.',$article->ArtikelpreisBrutto);
			}
			if($article->ArtikelPreisBeziehtSichAufMenge == 1)
			{
				$updateQuery = "UPDATE products SET products_price = '".$Preis."' WHERE products_model = '".$articleNr."'";
				
				$result = mysqli_query($GLOBALS['sql_con'], $updateQuery);

				switch ($GLOBALS['attributes_import'])
				{
					case 1:
						foreach($attributes as $attribute)
						{
							if ($attribute["AttributeName"] == $articleNr)
							{
								$pricePrefix = $attribute["ProductPrice"] <= $Preis ? "+" : "-";
								$Preis = abs($Preis - $attribute["ProductPrice"]);

								$query  = "UPDATE products_attributes SET options_values_price = '".$Preis."'";
								$query .= ", price_prefix = '".$pricePrefix."'";
								$query .= " WHERE products_attributes_id = " . $attribute["AttributeId"];

								$result = mysqli_query($GLOBALS['sql_con'], $query);
							}
						}
						break;
					case 2:
						$query = "
							SELECT combis.Id, combis.productId
							FROM
								(SELECT
								ppi.products_properties_combis_id as Id,
								ppi.products_id as productId,
								CONCAT(p.products_model, '-', GROUP_CONCAT(ppi.properties_values_id ORDER BY ppi.properties_id SEPARATOR '-')) as product_combination_id
								FROM products p
								LEFT JOIN
									products_properties_index ppi ON (ppi.products_id = p.products_id AND ppi.language_id = ".$GLOBALS['articles_language'].")
								GROUP BY
									ppi.products_properties_combis_id
								ORDER BY
									p.products_id) as combis
							WHERE
								combis.product_combination_id = '$articleNr'";

						$resultSet = mysqli_query($GLOBALS['sql_con'], $query);
						$combiId = mysqli_result($resultSet);
						$productId = mysqli_result($resultSet, 0, 1);

						if ($combiId)
						{
							$query = "SELECT products_price FROM products WHERE products_id = $productId";
							$productPrice = (float)mysqli_result(mysqli_query($GLOBALS['sql_con'], $query));

							$Preis = $Preis - $productPrice;
							$query = "UPDATE products_properties_combis SET combi_price = $Preis WHERE products_properties_combis_id = $combiId";
							$result = mysqli_query($GLOBALS['sql_con'], $query);
						}
						break;
					case 3:
						$query = "
							SELECT combis.Id, combis.productId
							FROM
							(
								SELECT
									ppc.products_properties_combis_id as Id,
									p.products_id as productId,
									CONCAT(p.products_model, \"-\", ppc.combi_model) as sku
								FROM products_properties_combis ppc
								INNER JOIN products p
								ON (p.products_id = ppc.products_id)
							) as combis
							WHERE combis.sku = '$articleNr'";

						$resultSet = mysqli_query($GLOBALS['sql_con'], $query);
						$combiId = mysqli_result($resultSet);
						$productId = mysqli_result($resultSet, 0, 1);

						if ($combiId)
						{
							$query = "SELECT products_price FROM products WHERE products_id = $productId";
							$productPrice = (float)mysqli_result(mysqli_query($GLOBALS['sql_con'], $query));

							$Preis = $Preis - $productPrice;
							$query = "UPDATE products_properties_combis SET combi_price = $Preis WHERE products_properties_combis_id = $combiId";
							$result = mysqli_query($GLOBALS['sql_con'], $query);
						}
						break;
				}
				
				if ($result > 0) $amount_successfully_created++;
			}
		}
		WriteXMLResult($amount_articles,$amount_successfully_created);
	}
}

function artikeldaten_shop_zu_orgamax()
{
	// Daten werden als Query übergeben
	$GLOBALS['datakind'] = "1";

	// Pagination
	$limit = (int)$_GET['limit'] ?: 0;
	$offset = (int)$_GET['offset'] ?: 0;
	
	$mwstSql = "	(
		select tax_rates.tax_rate
		from tax_rates
		where tax_rates.tax_class_id = products.products_tax_class_id
		and tax_rates.tax_zone_id in (".$GLOBALS['TAX_ZONE_ID'].")
		order by tax_rates.tax_priority
		limit 1
	) AS MwStValue,";

	switch ($GLOBALS['attributes_import'])
	{
		case 1:
			$GLOBALS['query'] = "
				SELECT
					products.products_id as productID,
					products.products_model as ArtikelnummerWebshop,
					products_description.products_name as Artikelbeschreibung,
					products_description.products_description as Anmerkungen,
					".$mwstSql."
					products.products_weight as Gewicht,
					products.products_price as ArtikelpreisNetto,
					products_vpe.products_vpe_name as Einheit,
					products_attributes.products_attributes_id AS Var_Id,
					products_attributes.price_prefix AS Var_Preis_Praefix,
					products_attributes.options_values_price AS Var_Preis,
					products_attributes.weight_prefix AS Var_Gewicht_Praefix,
					products_attributes.options_values_weight AS Var_Gewicht,
					products_options.products_options_name AS Var_Wert_Name,
					products_options_values.products_options_values_name AS Var_Wert				
				FROM products
				INNER JOIN
					products_description ON (products.products_id = products_description.products_id AND products_description.language_id = ".$GLOBALS['articles_language'].")
				LEFT OUTER JOIN
					products_vpe ON (products.products_vpe = products_vpe.products_vpe_id AND products_vpe.language_id = ".$GLOBALS['articles_language'].")
				LEFT OUTER JOIN
					products_attributes ON (products.products_id = products_attributes.products_id)
				LEFT OUTER JOIN
					products_options ON (products_attributes.options_id = products_options.products_options_id AND products_options.language_id = ".$GLOBALS['articles_language'].")
				LEFT OUTER JOIN
					products_options_values ON (products_attributes.options_values_id = products_options_values.products_options_values_id AND products_options_values.language_id = ".$GLOBALS['articles_language'].") 
				ORDER BY
					products.products_id";
			break;
		case 2:
			$GLOBALS['query'] = "
				SELECT
					p.products_id as productID,
					p.products_model as ArtikelnummerWebshop,
					p.products_price as ArtikelpreisNetto,
					p.products_weight as Gewicht,
					pd.products_name as Artikelbeschreibung,
					pd.products_description as Anmerkungen,
					".str_replace("products.", "p.", $mwstSql)."
					pvpe.products_vpe_name as Einheit,
					GROUP_CONCAT(ppi.properties_values_id ORDER BY ppi.properties_id SEPARATOR '-') as product_combination_id,
					GROUP_CONCAT(CONCAT(ppi.properties_name, ': ', ppi.values_name) ORDER BY ppi.properties_id SEPARATOR '\\n- ') as product_combination,
					p.products_price + ppc.combi_price as total_price
				FROM products p
				INNER JOIN
					products_description pd ON (pd.products_id = p.products_id AND pd.language_id = ".$GLOBALS['articles_language'].")
				LEFT JOIN
					products_properties_index ppi ON (ppi.products_id = p.products_id AND ppi.language_id = ".$GLOBALS['articles_language'].")
				LEFT JOIN
					products_properties_combis ppc ON (ppc.products_properties_combis_id = ppi.products_properties_combis_id)
				LEFT OUTER JOIN
					products_vpe pvpe ON (pvpe.products_vpe_id = p.products_vpe AND pvpe.language_id = ".$GLOBALS['articles_language'].")
				GROUP BY
					p.products_id, ppi.products_properties_combis_id
				ORDER BY
					p.products_id, ppi.value_sort_order";
			break;
		case 3:
			$GLOBALS['query'] = "
				SELECT
					p.products_id as productID,
					p.products_model as ArtikelnummerWebshop,
					p.products_price as ArtikelpreisNetto,
					p.products_weight as Gewicht,
					pd.products_name as Artikelbeschreibung,
					pd.products_description as Anmerkungen,
					".str_replace("products.", "p.", $mwstSql)."
					pvpe.products_vpe_name as Einheit,
					ppc.combi_model as xCombiModel,
					GROUP_CONCAT(CONCAT(ppi.properties_name, ': ', ppi.values_name) ORDER BY ppi.properties_id SEPARATOR '\\n- ') as product_combination,
					p.products_price + ppc.combi_price as total_price
				FROM products p
				INNER JOIN
					products_description pd ON (pd.products_id = p.products_id AND pd.language_id = ".$GLOBALS['articles_language'].")
				LEFT JOIN
					products_properties_index ppi ON (ppi.products_id = p.products_id AND ppi.language_id = ".$GLOBALS['articles_language'].")
				LEFT JOIN
					products_properties_combis ppc ON (ppc.products_properties_combis_id = ppi.products_properties_combis_id)
				LEFT OUTER JOIN
					products_vpe pvpe ON (pvpe.products_vpe_id = p.products_vpe AND pvpe.language_id = ".$GLOBALS['articles_language'].")
				GROUP BY
					p.products_id, ppi.products_properties_combis_id
				ORDER BY
					p.products_id, ppi.value_sort_order";
			break;
		default:
			$GLOBALS['query'] = "
				SELECT
					products.products_id as productID,
					products.products_model as ArtikelnummerWebshop,
					products_description.products_name as Artikelbeschreibung,
					products_description.products_description as Anmerkungen,
					".$mwstSql."
					products.products_weight as Gewicht,
					products.products_price as ArtikelpreisNetto,
					products_vpe.products_vpe_name as Einheit
				FROM products
				INNER JOIN
					products_description ON (products.products_id = products_description.products_id AND products_description.language_id = ".$GLOBALS['articles_language'].")
				LEFT OUTER JOIN
					products_vpe ON (products.products_vpe = products_vpe.products_vpe_id AND products_vpe.language_id = ".$GLOBALS['articles_language'].")	
				ORDER BY
					products.products_id";
			break;
	}

	if ($limit > 0) $GLOBALS['query'] .= " LIMIT $limit OFFSET $offset";
	
	return $GLOBALS['datakind'];
	
}// artikeldaten_shop_zu_orgamax

function artRow_ueberpruefen($artRow)
{
	$artRow['Artikelkategorie'] = '';

	# Artikeltexte kodieren
	$artRow['Artikelbeschreibung'] = strip_tags($artRow['Artikelbeschreibung']);
	$artRow['Anmerkungen'] = html_entity_decode($artRow['Anmerkungen'], ENT_QUOTES, 'utf-8');
	
	# MwSt richtig formatieren
	$artRow['MwStValue'] = (string)(double)$artRow['MwStValue'];
	
	# Artikelkategorie ermitteln
	$query = "SELECT categories_description.categories_name as Artikelkategorie ";
	$query .= "FROM products_to_categories ";
	$query .= "INNER JOIN categories_description ON (products_to_categories.categories_id = categories_description.categories_id AND categories_description.language_id = ".$GLOBALS['articles_language'].") ";
	$query .= "WHERE products_to_categories.products_id='".$artRow["productID"]."' AND products_to_categories.categories_id<>'0'";
	$qRes = mysqli_query($GLOBALS['sql_con'], $query);
	
	if ($qRes)
	{
		while ($qRow = mysqli_fetch_assoc($qRes))
		{
			$artRow['Artikelkategorie'] .= $qRow['Artikelkategorie'] . ";";
		} // Alle gefundenen Artikelkategorien durchgehen
		$artRow['Artikelkategorie'] = substr($artRow['Artikelkategorie'],0,strlen($artRow['Artikelkategorie'])-1);
	} // Wenn eine Artikelkategorie gefunden wurde
	
	# Artikelattribute berücksichtigen
	switch ($GLOBALS['attributes_import'])
	{
		case 1:
			// Artikelnummer nur abändern, wenn auch Attributsänderungen vorhanden sind
			if ($artRow["Var_ArtikelnummerWebshop"] <> "")
			{
				$artRow["ArtikelnummerWebshop"] .= htmlspecialchars($artRow["Var_ArtikelnummerWebshop"]);
			}
			else if (!empty($artRow["Var_Wert"]))
			{
				$artRow["ArtikelnummerWebshop"] .= "-" . $artRow["Var_Wert"];
			}

			if ($artRow["Var_Wert"] <> "")
			{
				$artRow["Artikelbeschreibung"] .= htmlspecialchars(" - " . $artRow["Var_Wert_Name"] . ": " . $artRow["Var_Wert"]);
			}

			if ($artRow["Var_Gewicht"] <> "")
			{
				if($artRow['Var_Gewicht_Praefix'] == '+')
				{
					$artRow['Gewicht'] = (double)$artRow['Gewicht'] + (double)$artRow['Var_Gewicht'];
				}
				else if($artRow['Var_Gewicht_Praefix'] == '-')
				{
					$artRow['Gewicht'] = (double)$artRow['Gewicht'] - (double)$artRow['Var_Gewicht'];
				}
			}

			if ($artRow["Var_Preis"])
			{
				if($artRow['Var_Preis_Praefix'] == '+')
				{
					$artRow['ArtikelpreisNetto'] = (double)$artRow['ArtikelpreisNetto'] + (double)$artRow['Var_Preis'];
				}
				else if($artRow['Var_Preis_Praefix'] == '-')
				{
					$artRow['ArtikelpreisNetto'] = (double)$artRow['ArtikelpreisNetto'] - (double)$artRow['Var_Preis'];
				}
			}

			break;
		case 2:
			if (!empty($artRow['total_price'])) $artRow['ArtikelpreisNetto'] = (double)$artRow['total_price'];
			if (!empty($artRow['product_combination_id'])) $artRow["ArtikelnummerWebshop"] .= '-' . $artRow["product_combination_id"];
			if (!empty($artRow['product_combination'])) $artRow["Artikelbeschreibung"] = $artRow["Artikelbeschreibung"] . "\n- " . $artRow['product_combination'];

			break;
		case 3:
			if (!empty($artRow['total_price'])) $artRow['ArtikelpreisNetto'] = (double)$artRow['total_price'];
			if (!empty($artRow['xCombiModel'])) $artRow["ArtikelnummerWebshop"] .= '-' . $artRow["xCombiModel"];
			if (!empty($artRow['product_combination'])) $artRow["Artikelbeschreibung"] = $artRow["Artikelbeschreibung"] . "\n- " . $artRow['product_combination'];

			break;
	}

	// Wenn die Artikelnummer im Webshop gleich der Artikelnummer in orgaMAX sein soll
	$artRow["Artikelnummer"] = '';
	
	return $artRow;
	
}// article_row_ueberpruefen

function status_aendern($orderId)
{
	include_once "inc/config.php";
	$ShopStatus = $GLOBALS["aendern_zu"];
	
	$query = "SELECT orders_status FROM orders where orders_id=$orderId";
	$qRes = mysqli_query($GLOBALS['sql_con'], $query);
	if ($qRes)
	{
		$row = mysqli_fetch_assoc($qRes);
		if ($row['orders_status'] != 3)
		{
			$query = "UPDATE orders Set orders_status = '$ShopStatus' WHERE orders_id = '$orderId'";
			mysqli_query($GLOBALS['sql_con'], $query);
			$error1 = mysqli_error($GLOBALS['sql_con']);
			$query = "INSERT INTO orders_status_history (orders_id, orders_status_id, date_added) VALUES ($orderId, $ShopStatus, '" . date("Y-m-d H:i:s") . "');";
			mysqli_query($GLOBALS['sql_con'], $query);
			$error2 = mysqli_error($GLOBALS['sql_con']);
			if (($error1 == '') and ($error2 == ''))
			{
				die(xml_success_ausgeben("Der Status der Bestellung '" . $orderId . "' wurde auf '" . $ShopStatus . "' gesetzt."));
			} // Fehler
			else 
			{
				die(xml_error_ausgeben("Bei der Statusänderung der Bestellung '$orderId' auf den Wert '$ShopStatus' trat ein Fehler auf. Beim ersten Query meldete MySql '$error1' und beim zweiten '$error2'.", __FILE__, __FUNCTION__, __LINE__));
			}
		} // Der aktuelle status ist != 3
		else 
		{
			die(xml_success_ausgeben("Der Status der Bestellung '" . $orderId . "' durfte nicht geändert werden, da er bereits den Wert '3' besitzt."));
		}
	} // Select query war erfolgreich
	else 
	{
		die(xml_error_ausgeben("Der Datensatz mit der Bestellnummer '" . $orderId . "' konnte nicht ermittelt werden.", __FILE__, __FUNCTION__, __LINE__));
	}
}

function starten()
{
	# Konfigurationsdatei vom Shopsystem einbinden und Verbindung zur Datenbank herstellen:

	if (file_exists(ORGAMAX_OS_CONFIG)) {
		include ORGAMAX_OS_CONFIG;
		
		$dbServer = explode(":", DB_SERVER);
		$GLOBALS['sql_con'] = mysqli_connect(array_shift($dbServer), DB_SERVER_USERNAME, DB_SERVER_PASSWORD, DB_DATABASE);
	}// Verbindung zur Datenbank herstellen:
	else
	{
		die (xml_error_ausgeben($GLOBALS['err_msg']['shop_cfg'],__FILE__, __FUNCTION__, __LINE__));
	}//Fehlermeldung ausgeben

	$charset = mysqli_character_set_name($GLOBALS['sql_con']);
	if($charset != 'utf8')
	{
		mysqli_set_charset($GLOBALS['sql_con'], 'utf8');
	}
}

function ende()
{
	mysqli_close($GLOBALS['sql_con']);
}

function hasSepaPlugin()
{
    $query = "SELECT COUNT(*) FROM information_schema.tables WHERE table_schema = '" . mysqli_real_escape_string($GLOBALS['sql_con'], DB_DATABASE) . "' AND table_name = 'sepa'";
    $result = mysqli_query($GLOBALS['sql_con'], $query);
    $hasSepaPlugin = (mysqli_num_rows($result) > 0) ? true : false;
    return $hasSepaPlugin;
}

function getPreCalculateAttributes()
{
	$attributes = array();
	if ($GLOBALS['attributes_import'] === 1)
	{
		$selectQuery = "
			SELECT
				products.products_model,
				products.products_price,
				products_attributes.products_attributes_id AS Var_Id,
				products_options_values.products_options_values_name AS Var_Wert
			FROM products
			INNER JOIN
				products_description ON (products.products_id = products_description.products_id AND products_description.language_id = ".$GLOBALS['articles_language'].")
			LEFT OUTER JOIN
				products_attributes ON (products.products_id = products_attributes.products_id)
			LEFT OUTER JOIN
				products_options ON (products_attributes.options_id = products_options.products_options_id AND products_options.language_id = ".$GLOBALS['articles_language'].")
			LEFT OUTER JOIN
				products_options_values ON (products_attributes.options_values_id = products_options_values.products_options_values_id
				AND products_options_values.language_id = ".$GLOBALS['articles_language'].")
			ORDER BY
				products.products_id";

		$result = mysqli_query($GLOBALS['sql_con'], $selectQuery);

		if(mysqli_num_rows($result) > 0)
		{
			while($article = mysqli_fetch_assoc($result))
			{
				if (!empty($article["Var_Wert"]))
				{
					$attributes[] = array(
						"AttributeId" => $article["Var_Id"],
						"AttributeName" => $article["products_model"] . "-" . $article["Var_Wert"],
						"ProductPrice" => $article["products_price"]
					);
				}
			}
		}
	}

	return $attributes;
}

function paging_informationen()
{
	$selectQuery = null;

	switch ($GLOBALS['attributes_import'])
	{
		case 1:
			$selectQuery = "
				SELECT
					1
				FROM products
				INNER JOIN
					products_description ON (products.products_id = products_description.products_id AND products_description.language_id = ".$GLOBALS['articles_language'].")
				LEFT OUTER JOIN
					products_attributes ON (products.products_id = products_attributes.products_id)
				LEFT OUTER JOIN
					products_options ON (products_attributes.options_id = products_options.products_options_id AND products_options.language_id = ".$GLOBALS['articles_language'].")
				LEFT OUTER JOIN
					products_options_values ON (products_attributes.options_values_id = products_options_values.products_options_values_id AND products_options_values.language_id = ".$GLOBALS['articles_language'].")
				ORDER BY
					products.products_id";
			break;
		case 2:
			$selectQuery = "
				SELECT
					1
				FROM products
				INNER JOIN
					products_description ON (products.products_id = products_description.products_id AND products_description.language_id = ".$GLOBALS['articles_language'].")
				LEFT JOIN
					products_properties_index ON (products_properties_index.products_id = products.products_id AND products_properties_index.language_id = ".$GLOBALS['articles_language'].")
				GROUP BY
					products_properties_index.products_properties_combis_id
				ORDER BY
					products.products_id";
			break;
		case 3:
			$selectQuery = "
				SELECT
					1
				FROM products
				INNER JOIN
					products_description ON (products_description.products_id = products.products_id AND products_description.language_id = ".$GLOBALS['articles_language'].")
				LEFT JOIN
					products_properties_combis ON (products_properties_combis.products_id = products.products_id)";
			break;
		default:
			$selectQuery = "
				SELECT
					1
				FROM products
				INNER JOIN
					products_description ON (products.products_id = products_description.products_id AND products_description.language_id = ".$GLOBALS['articles_language'].")
				ORDER BY
					products.products_id";
			break;
	}

	// Count-Query
	$selectQuery = "SELECT COUNT(*) FROM (".$selectQuery.") counttable";

	/** XML-Dokument erzeugen */
	$dom = new DomDocument('1.0');
	$dom->xmlStandalone = true;
	$dom->encoding = "utf-8";

	$infoNode = $dom->appendChild($dom->createElement('PagingInformations'));
	$result = mysqli_query($GLOBALS['sql_con'], $selectQuery);

	if (mysqli_num_rows($result) > 0)
	{
		Add_NewDocElement($dom, $infoNode, 'ArticleCount', mysqli_result($result));
	}

	$dom->formatOutput = true;
	echo $dom->saveXML();
}

/**
 * @param integer $id
 * @param string $houseNumberField
 * @return string
 */
function getHouseNumber($id, $houseNumberField)
{
	if (!$id || !$houseNumberField) return "";
	$columnCheck = mysqli_query($GLOBALS['sql_con'], "SHOW COLUMNS FROM `orders` LIKE '".$houseNumberField."'");
	if (mysqli_num_rows($columnCheck))
	{
		$query = "SELECT ".$houseNumberField." FROM orders WHERE orders_id = ".$id;
		$qRes = mysqli_query($GLOBALS['sql_con'], $query);
		if ($qRes)
		{
			$result = mysqli_result($qRes);
			if (!empty(trim($result))) return " ".trim($result);
		}
	}

	return "";
}

?>