<?PHP
/***************************************************************************\
*
*	Copyright (c) 2013 deltra Business Software GmbH & Co. KG
*	http://www.deltra.de
*
\***************************************************************************/
$GLOBALS['VERSION_SCF'] = "4.0.00";

function starten()
{
	// dummy
}

function daten_holen()
{
	// datakind == 1 => Daten werden als Query verarbeitet
	// datakind == 2 => Daten werden als Array verarbeitet
	// datakind == 3 => Daten werden als XMLDoc durchgereicht
	
	$GLOBALS['datakind'] = "3";
	
    try {
		/** Magento Framework laden*/
        //
        //  !!! Datei-Referenz bitte anpassen !!!
        //
        require_once(REF_MAGE);
        Mage::app();
		
        /** XML-Dokument erzeugen */
        $dom = new DomDocument('1.0');
        $dom->xmlStandalone = true;
        $dom->encoding="utf-8";

        /** orgaMax oberstes Knotenelement */
        $domOrders = $dom->appendChild($dom->createElement('OrderNotification'));
		
		/** Erforderliche Magento Modelle heranziehen */
		$ordersMag = Mage::getModel('sales/order')->getCollection()
			->join(
				array('payment'=>'sales/order_payment'),
				'main_table.entity_id=payment.parent_id',
				array('payment_method'=>'payment.method')
			);
		
        /**
         * Magento Basis-Stati Verkaufaufträge (sales_ order_states)
         * pending
         * processing
         * complete
         * closed
         * canceled
         * holded
         */
        $status = 'pending';
        switch($GLOBALS["DEFAULT_ORDERS_STATUS"])
        {
        	case 0:
        		$status = 'pending';
        		break;
        	case 1:
        		$status = 'processing';
        		break;
        	case 2:
        		$status = 'complete';
        		break;
        	case 3:
        		$status = 'closed';
        		break;
        	case 4:
        		$status = 'canceled';
        		break;
        	case 5:
        		$status = 'holded';
        		break;
        }

		/** orgaMax Importfilter für Verkaufsaufträge */
		$ordersMag->addFieldToFilter('status', array('eq'=>$status));

        /** Alle gefilterten Verkaufsaufträge holen */
        $colOrderIDs = $ordersMag->getAllIds();

		/** PayPal-Bestellungen haben IMMER den Status 'processing'
		 *  und müssen gesondert abgerufen werden */
		$ordersMag->clear()->getSelect()->reset('where');
		$ordersMag
			->addFieldToFilter('status', array('eq'=>'processing'))
			->addFieldToFilter('payment.method', array('like'=>'%paypal%'));
		$colOrderIDs = array_unique(array_merge($colOrderIDs, $ordersMag->getAllIds()), SORT_REGULAR);
		
		/** Hauptschleife */
        foreach($colOrderIDs as $loopOrderID)
		{
            $tmpOrder = Mage::getModel('sales/order');
            $tmpOrder->load($loopOrderID);
			
            /** orgaMax Knoten Bestellvorgang */
            $domOrder = $domOrders->appendChild($dom->createElement('Bestellvorgang'));
            $orderData = $tmpOrder->getData();
			
            $streetBA=$tmpOrder->getBillingAddress()->getStreet();
            $customer = Mage::getModel('customer/customer')->load($orderData['customer_id'])->getData();
			
            //Alle Bezahlinformationen
            $paymentInformation = $tmpOrder->getPayment()->toArray();
			
			/** orgamax Bestellvorgang  Daten */
            Add_NewDocElement($dom, $domOrder, 'BestellnummerShop', $orderData['increment_id']);     //$tmpOrder->getData('increment_id'));
            Add_NewDocElement($dom, $domOrder, 'Bestelldatum', strftime("%Y-%m-%d %H:%M:%S",strtotime($orderData['created_at'])));
            Add_NewDocElement($dom, $domOrder, 'Wunschlieferdatum', '');                        //In Magento nicht vorhanden.			
			
            //2011-04-19,HM, Transportmethode
            //     ggf. Transportunternehmen 'shipping_description'
            Add_NewDocElement($dom, $domOrder, 'Lieferart', $orderData['shipping_method']);
            //2011-04-19,HM, Zahlungsmethode/Zahlungsart
            Add_NewDocElement($dom, $domOrder, 'Zahlungsart', $paymentInformation["method"]);
			
			// Zusatzfelder setzen
			Add_NewDocElement($dom, $domOrder, 'ZusatzfeldBestellung1', '');
			Add_NewDocElement($dom, $domOrder, 'ZusatzfeldBestellung2', '');
			Add_NewDocElement($dom, $domOrder, 'ZusatzfeldBestellung3', '');
			Add_NewDocElement($dom, $domOrder, 'ZusatzfeldBestellung4', '');
			Add_NewDocElement($dom, $domOrder, 'ZusatzfeldBestellung5', '');
			Add_NewDocElement($dom, $domOrder, 'AnmerkungenBestellung', $orderData['customer_note']);

			/** orgaMax Knoten Kundendaten */
            $domCustomerData = $domOrder->appendChild($dom->createElement('Kundendaten'));
            /** orgaMax Knoten Kunde */
            $domCustormer = $domCustomerData->appendChild($dom->createElement('Kunde'));
            /** orgaMax Knoten Kunde Daten */
            Add_NewDocElement($dom, $domCustormer, 'Kundennummer', ''); // Magento bietet nicht die Möglichkeit eine eigene Kundennummer zu hinterlegen
            Add_NewDocElement($dom, $domCustormer, 'KundennummerWebshop', $orderData['customer_id']);
            Add_NewDocElement($dom, $domCustormer, 'Firmenname', $tmpOrder->getBillingAddress()->getCompany());

            Add_NewDocElement($dom, $domCustormer, 'Firmenzusatzname', '');
            Add_NewDocElement($dom, $domCustormer, 'PersonAnrede', $orderData['customer_prefix']);

            Add_NewDocElement($dom, $domCustormer, 'PersonGeschlecht', $orderData['customer_gender']);
            Add_NewDocElement($dom, $domCustormer, 'PersonTitel', '');

			/** Personenname bei Gastbestellungen von der Rechnungsadresse übernehmen */
			if ($orderData['customer_id'] === null) {
				Add_NewDocElement($dom, $domCustormer, 'PersonNachname', $tmpOrder->getBillingAddress()->getLastname());
				Add_NewDocElement($dom, $domCustormer, 'PersonVorname', $tmpOrder->getBillingAddress()->getFirstname());
			}
			else {
				Add_NewDocElement($dom, $domCustormer, 'PersonNachname', $orderData['customer_lastname']);
				Add_NewDocElement($dom, $domCustormer, 'PersonVorname', $orderData['customer_firstname']);
			}
			
            Add_NewDocElement($dom, $domCustormer, 'Strasse', $streetBA[0]);
            Add_NewDocElement($dom, $domCustormer, 'Postleitzahl', $tmpOrder->getBillingAddress()->getPostcode());
            Add_NewDocElement($dom, $domCustormer, 'Ort', $tmpOrder->getBillingAddress()->getCity());
            Add_NewDocElement($dom, $domCustormer, 'Laendercode', LaenderKuerzelISO2OMX($tmpOrder->getBillingAddress()->getData('country_id')));
            Add_NewDocElement($dom, $domCustormer, 'Land', $tmpOrder->getBillingAddress()->getRegion());
            Add_NewDocElement($dom, $domCustormer, 'Email', $orderData['customer_email']);
            Add_NewDocElement($dom, $domCustormer, 'Telefon', $tmpOrder->getBillingAddress()->getData('telephone'));
            Add_NewDocElement($dom, $domCustormer, 'Fax', $tmpOrder->getBillingAddress()->getData('fax'));
            Add_NewDocElement($dom, $domCustormer, 'Umsatzsteueridentnummer', $customer['taxvat']);
            Add_NewDocElement($dom, $domCustormer, 'ZusatzfeldKunde1', '');
            Add_NewDocElement($dom, $domCustormer, 'ZusatzfeldKunde2', '');
            Add_NewDocElement($dom, $domCustormer, 'ZusatzfeldKunde3', '');
            Add_NewDocElement($dom, $domCustormer, 'ZusatzfeldKunde4', '');
            Add_NewDocElement($dom, $domCustormer, 'ZusatzfeldKunde5', '');
			
			/** orgaMax Knoten Kontodaten */
            $domAccountData = $domCustomerData->appendChild($dom->createElement('Kontodaten'));
			
            /** orgaMax Kontodaten */			
			$bankinfo = array(
				"name" => "",
				"number" => "",
				"blz" => "",
				"bankname" => "",
				"swift" => "",
				"iban" => "");
			$orderPayment = $tmpOrder->getPayment();
			if (!is_null($orderPayment->getMethodInstance))
			{
				$bankData = $tmpOrder->getPayment()->getMethodInstance();
				$bankinfo["name"] = $bankData->getAccountName();
				$bankinfo["number"] = $bankData->getAccountNumber();
				$bankinfo["blz"] = $bankData->getAccountBLZ();
				$bankinfo["bankname"] = $bankData->getAccountBankname();
				$bankinfo["swift"] = $bankData->getAccountSwift();
				$bankinfo["iban"] = $bankData->getAccountIban();
				
				// MR: 12.02.2014
				// Sollte der Bankname nicht vorhanden sein, so wird ein Leerstring zurückgegeben.
				if (strtolower($bankinfo["bankname"]) == "not available") $bankinfo["bankname"] = "";
			}
			
			Add_NewDocElement($dom, $domAccountData, 'BankkontoInhaber', $bankinfo["name"]);
			Add_NewDocElement($dom, $domAccountData, 'Bankkontonummer', $bankinfo["number"]);
			Add_NewDocElement($dom, $domAccountData, 'BankkontoBLZ', $bankinfo["blz"]);
			
            Add_NewDocElement($dom, $domAccountData, 'BankkontoBankName', $bankinfo["bankname"]);
			Add_NewDocElement($dom, $domAccountData, 'BankkontoBIC', $bankinfo["swift"]);
			Add_NewDocElement($dom, $domAccountData, 'BankkontoIBAN', $bankinfo["iban"]);

            /** orgaMax Knoten AbweichendLieferung */
            $domDivergentShipment = $domCustomerData->appendChild($dom->createElement('AbweichendLieferung'));
			
            /** orgaMax AbweichendLieferung Daten*/
			if ($tmpOrder->getShippingAddress()) {
				$streetSA=$tmpOrder->getShippingAddress()->getStreet(); 
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungFirmenname', $tmpOrder->getShippingAddress()->getCompany());            
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungFirmenzusatz', '');
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersAnrede', $tmpOrder->getShippingAddress()->getPrefix());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersGeschl', '');
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersTitel', '');
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersNachname', $tmpOrder->getShippingAddress()->getLastname());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersVorname', $tmpOrder->getShippingAddress()->getFirstname());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungStrasse', $streetSA[0]);
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPostleitzahl', $tmpOrder->getShippingAddress()->getPostcode());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungOrt', $tmpOrder->getShippingAddress()->getCity());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungLaendercode', LaenderkuerzelISO2OMX($tmpOrder->getShippingAddress()->getData('country_id')));
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungLand', $tmpOrder->getShippingAddress()->getRegion());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungEmail', '');
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungTelefon', $tmpOrder->getShippingAddress()->getData('telephone'));
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungFax', $tmpOrder->getShippingAddress()->getData('fax'));
			}
			else {
				$streetSA=$tmpOrder->getBillingAddress()->getStreet();
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungFirmenname', $tmpOrder->getBillingAddress()->getCompany());            
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungFirmenzusatz', '');
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersAnrede', $tmpOrder->getBillingAddress()->getPrefix());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersGeschl', '');
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersTitel', '');
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersNachname', $tmpOrder->getBillingAddress()->getLastname());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPersVorname', $tmpOrder->getBillingAddress()->getFirstname());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungStrasse', $streetSA[0]);
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungPostleitzahl', $tmpOrder->getBillingAddress()->getPostcode());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungOrt', $tmpOrder->getBillingAddress()->getCity());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungLaendercode', LaenderkuerzelISO2OMX($tmpOrder->getBillingAddress()->getData('country_id')));
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungLand', $tmpOrder->getBillingAddress()->getRegion());
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungEmail', '');
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungTelefon', $tmpOrder->getBillingAddress()->getData('telephone'));
				Add_NewDocElement($dom, $domDivergentShipment, 'abweichendLieferungFax', $tmpOrder->getBillingAddress()->getData('fax'));
			}

			/** orgaMax Knoten AbweichendRechnung */
            $domDivergentInvoice = $domCustomerData->appendChild($dom->createElement('AbweichendRechnung'));
            /** orgaMax AbweichendRechnung Daten*/
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungFirmenname', $tmpOrder->getBillingAddress()->getCompany());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungFirmenzusatz', '');
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPersAnrede',$tmpOrder->getBillingAddress()->getPrefix());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPersGeschl', ''); 
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPersTitel', ''); 
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPersNachname', $tmpOrder->getBillingAddress()->getLastname());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPersVorname', $tmpOrder->getBillingAddress()->getFirstname());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungStrasse', $streetBA[0]);
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungPostleitzahl', $tmpOrder->getBillingAddress()->getPostcode());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungOrt', $tmpOrder->getBillingAddress()->getCity());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungLaendercode', LaenderkuerzelISO2OMX($tmpOrder->getBillingAddress()->getData('country_id')));
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungLand', $tmpOrder->getBillingAddress()->getRegion());
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungEmail', '');
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungTelefon', $tmpOrder->getBillingAddress()->getData('telephone'));
            Add_NewDocElement($dom, $domDivergentInvoice, 'abweichendRechnungFax', $tmpOrder->getBillingAddress()->getData('fax'));

            /** orgaMax Knoten Frachtkosten */
            $domFreightCharges = $domCustomerData->appendChild($dom->createElement('Frachtkosten'));
            /** orgaMax Frachtkosten Daten*/
  
            //2011-04-19,HM, Frachtkosten-Nettobetrag
            Add_NewDocElement($dom, $domFreightCharges, 'FrachtkostenNetto', $orderData['shipping_amount']);
            //2011-04-19,HM, Frachtkosten-Bruttobetrag
            Add_NewDocElement($dom, $domFreightCharges, 'FrachtkostenBrutto',$orderData['shipping_amount'] + $orderData['shipping_tax_amount']);
            Add_NewDocElement($dom, $domFreightCharges, 'FrachtkostenMwStProzent', '');

            /** orgaMax Knoten Zuschlagkosten */
            $domaAditionalCosts = $domOrder->appendChild($dom->createElement('Zuschlagkosten'));
            /** orgaMax Zuschlagkosten Daten*/
			$discountAmount = ($orderData['discount_amount'] <> 0) ? $orderData['discount_amount'] : '';
			$paymentCharge = ($orderData['payment_charge'] <> 0) ? $orderData['payment_charge'] : '';
			
			Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenNetto1', $discountAmount);
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenBrutto1', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenMwStProzent1', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenNetto2', $paymentCharge);
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenBrutto2', $paymentCharge);
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenMwStProzent2', empty($paymentCharge) ? '' : 0.0);
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenNetto3', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenBrutto3', '');
            Add_NewDocElement($dom, $domaAditionalCosts, 'ZuschlagkostenMwStProzent3', '');

			/* orgaMax Knoten Bestellartikel */
            foreach ($tmpOrder->getItemsCollection() as $item)
			{
				$itemData = $item->getOrigData();
				if($itemData['parent_item_id'] != null){
					continue;
				}
				// MR: 28.09.2012 - Menge des bestellten Artikels auslesen, da für Berechnung der RabattProzente benötigt
				$itemQuantity = $item->getQtyOrdered();
				
				$productSku = $item->getSku() ? $item->getSku() : $item->getProduct()->getSku();
				$productName = $item->getName();
				$productOptions = $item->getProductOptions();
				
				if (property_exists($productOptions, "options") || isset($productOptions["options"]))
				{
					$itemOptions = $productOptions["options"];
					foreach ($itemOptions as $itemOption)
					{
						$productName .= " - ".$itemOption['value'];
					}
				}
				
				$domOrderItem = $domOrder->appendChild($dom->createElement('BestellArtikel'));
				
                 /* orgaMax Bestellartikel Daten*/
                Add_NewDocElement($dom, $domOrderItem,'Positionsnummer',$item['item_id']); //Magento unterhält keine Positionsnummer
                Add_NewDocElement($dom, $domOrderItem,'Artikelnummer', ($GLOBALS['artno_handling'] == 1) ? $productSku : '');
                Add_NewDocElement($dom, $domOrderItem,'ArtikelnummerShop',$productSku);
                Add_NewDocElement($dom, $domOrderItem,'Menge', $itemQuantity);
                Add_NewDocElement($dom,$domOrderItem, 'Gewicht',$itemData['weight']);
                Add_NewDocElement($dom, $domOrderItem,'abweichenderEinzelpreisNetto', $item->getPrice());
                //2011-04-18,HM, EinzelpreisBrutto);
                Add_NewDocElement($dom, $domOrderItem,'abweichenderEinzelpreisBrutto', $item->getPriceInclTax());
                Add_NewDocElement($dom, $domOrderItem,'abweichendeMwStProzent', $itemData['tax_percent']);
                //2011-04-19,HM, Artikelname (-bezeichnung) in abweichenden Artikeltext eingefügt.
                Add_NewDocElement($dom, $domOrderItem,'abweichenderArtikeltext', $productName);
                // 2011-04-18,HM, RabattBetrag erhält man über $item->getDiscountAmount()
                // Add_NewDocElement($dom, $domOrderItem,'RabattProzent', $itemData['discount_percent']);
                Add_NewDocElement($dom, $domOrderItem,'RabattProzent', '');
				Add_NewDocElement($dom, $domOrderItem,'ZusatzfeldPosition1','');
                //2011-04-19,HM, Artikelgewicht
                Add_NewDocElement($dom, $domOrderItem,'ZusatzfeldPosition2','');
                Add_NewDocElement($dom, $domOrderItem,'ZusatzfeldPosition3','');
                Add_NewDocElement($dom, $domOrderItem,'ZusatzfeldPosition4','');
                Add_NewDocElement($dom, $domOrderItem,'ZusatzfeldPosition5','');
			}
			
			// MR: 08.08.2012
			// Statusänderung in Funktion status_aendern() ausgelagert, um Funktionalität
			// mit ShopConnector zu gewährleisten.
            $tmpOrder->save();
        }
		
		$dom->formatOutput = true;
        $GLOBALS['XMLDoc'] = $dom->saveXML();
        return $GLOBALS['datakind'];

    } catch (Exception $e) {

        $catchExeption='<?xml version="1.0" encoding="utf-8"?>'."\n".
        '<orgamax_phperror>'."\n".
        '<message>'.utf8_encode($e->getMessage()).'</message>'."\n".
        '<phpfile>'.utf8_encode(__FILE__).'</phpfile>'."\n".
        '<function>'.utf8_encode(__FUNCTION__).'</function>'."\n".
        '<line>'.utf8_encode(__LINE__).'</line>'."\n".
        '<errortime>'.utf8_encode(date("Y-m-d H:i:s")).'</errortime>'."\n".
        '</orgamax_phperror>';
        die ($catchExeption);
    }
}

function artikeldaten_shop_zu_orgamax()
{
	$GLOBALS['datakind'] = '3';
	try {
		require_once(REF_MAGE);
	    
		Mage::app();
		
		/** XML-Dokument erzeugen */
	    $dom = new DomDocument('1.0');
	    $dom->xmlStandalone = true;
	    $dom->encoding="utf-8";
		 /** orgaMax oberstes Knotenelement */
        $domProducts = $dom->appendChild($dom->createElement('Artikelimport'));		
		
        //Alle Produkte auslesen 
        $model = Mage::getModel('catalog/product');
	
        $products = $model->getCollection()->addAttributeToSelect(array('sku', 'name', 'price', 'tax_class_id', 'cost'));
		/** @var $_taxHelper \Mage_Tax_Helper_Data */
		$_taxHelper = Mage::helper('tax');

		/** @var $rateModel \Mage_Tax_Model_Calculation */
		$rateModel = Mage::getSingleton('tax/calculation');
		$rateRequest = $rateModel->getRateRequest();

		// Produkte aus dem Magentoshop auslesen
		/** @var $product \Mage_Catalog_Model_Product */
		foreach($products as $product)
		{
			$artikelRow = $domProducts->appendChild($dom->createElement('row'));
			
			//nimmt nur die erste Kategorie von dem Produkt. Mehr als 1 ist nicht möglich
			$categoryName = '';
			foreach($product->getCategoryIds() as $categoryID)
			{
				$category = Mage::getModel('catalog/category')->load($categoryID);
				
				$categoryName = $category->getName();
				break;
			}
			
			// MwSt aus Produkt bestimmen
			$mwstValue = $rateModel->getRate($rateRequest->setData('product_class_id', $product->getData("tax_class_id")));
			
			// MR: 24.05.2013
			// Sonderbehandlung für konfigurierbare Artikel
			if(get_class($product->getPriceModel()) == "OrganicInternet_SimpleConfigurableProducts_Catalog_Model_Product_Type_Configurable_Price") continue;

			// MR: 28.09.2012
			// Nettopreis ermitteln effektiver und ohne eigene Prüfung durch taxHelper von magento
			$netPrice = $_taxHelper->getPrice( $product, (float)$product->getPrice(), false );
			$bruttoPrice = $_taxHelper->getPrice( $product, (float)$product->getPrice(), true );

			Add_NewDocElement($dom, $artikelRow, 'Artikelnummer', '');
			Add_NewDocElement($dom, $artikelRow, 'ArtikelnummerWebshop', $product->getData('sku'));
			Add_NewDocElement($dom, $artikelRow, 'Artikelbeschreibung', $product->getName());
			Add_NewDocElement($dom, $artikelRow, 'MwStCode', '');
			Add_NewDocElement($dom, $artikelRow, 'MwStValue', $mwstValue);
			Add_NewDocElement($dom, $artikelRow, 'Einheit', $product->getUnitMeasure());
			Add_NewDocElement($dom, $artikelRow, 'Artikelkategorie', $categoryName);
			Add_NewDocElement($dom, $artikelRow, 'Gewicht', $product->getWeight());
			Add_NewDocElement($dom, $artikelRow, 'Volumen', $product->getVolume());
			Add_NewDocElement($dom, $artikelRow, 'Anmerkungen',$product->getDescription());
			Add_NewDocElement($dom, $artikelRow, 'ArtikelpreisNetto', $netPrice);
			Add_NewDocElement($dom, $artikelRow, 'ArtikelpreisBrutto',$bruttoPrice);
			Add_NewDocElement($dom, $artikelRow, 'Einkaufspreis', $product->getData('cost'));
			Add_NewDocElement($dom, $artikelRow, 'Artikelbild', '');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld1', '');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld2', '');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld3', '');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld4', '');
			Add_NewDocElement($dom, $artikelRow, 'IndividuellesFeld5', '');
		}
		$dom->formatOutput = true;
        $GLOBALS['XMLDoc'] = $dom->saveXML();
        return $GLOBALS['datakind'];
	} 
	catch (Exception $e) {
		 $catchExeption='<?xml version="1.0" encoding="utf-8"?>'."\n".
        '<orgamax_phperror>'."\n".
        '<message>'.utf8_encode($e->getMessage()).'</message>'."\n".
        '<phpfile>'.utf8_encode(__FILE__).'</phpfile>'."\n".
        '<function>'.utf8_encode(__FUNCTION__).'</function>'."\n".
        '<line>'.utf8_encode(__LINE__).'</line>'."\n".
        '<errortime>'.utf8_encode(date("Y-m-d H:i:s")).'</errortime>'."\n".
        '</orgamax_phperror>';
        die ($catchExeption);
	}
}

function artikeldaten_orgamax_zu_shop()
{
	$articleFile = file_get_contents('php://input');
	if($articleFile != null && strlen($articleFile) > 0) {
		require_once(REF_MAGE);
		Mage::app();
		$articles = simplexml_load_string(($articleFile));
		
		$amount_successfully_created = 0;
		$amount_articles = count($articles);
		
		$categories = Mage::getModel('catalog/category');
		$categories->setStoreId(0);
		$tree = $categories->getTreeModel();
		$tree->load(); 
		$ids = $tree->getCollection()->getAllIds();
		
		$entityTypeId = Mage::getModel('eav/entity')
                ->setType('catalog_product')
                ->getTypeId();
				
		$attributeSetName   = 'Default';
		$attributeSetId     = Mage::getModel('eav/entity_attribute_set')
							->getCollection()
							->setEntityTypeFilter($entityTypeId)
							->addFieldToFilter('attribute_set_name', $attributeSetName)
							->getFirstItem()
							->getAttributeSetId();
							
		// Steuereinstellungen aus Magento ermitteln
		$taxInclusive = true;
		$coreConfigDataCollectionArray = Mage::getModel('core/config_data')->getCollection()->toArray();
		$coreConfigDataItems = $coreConfigDataCollectionArray['items'];
		foreach($coreConfigDataItems as $item)
		{
			if($item['path'] == 'tax/calculation/price_includes_tax')
			{
				$taxInclusive = ($item['value'] == 1) ? true : false;
			}
		}
		
		
		// Artikel verarbeiten
		foreach($articles as $article)
		{
			
			//Neues Artikel Objekt anlegen
			$newArticle = Mage::getModel('catalog/product');
				
			$newArticle->setStoreId(0);
			$newArticle->setWebsiteIds(array(1));
			$newArticle->setCategoryIds($ids[1]);
			$artikelname = htmlspecialchars(strip_tags($article->Artikelbeschreibung));
			
			$newArticle->setModel($article->ArtikelnummerWebshop);
			if($article->Anmerkungen != 'DSC_IGNORE')
			{
				$newArticle->setDescription($article->Anmerkungen);
			}
			$newArticle->setShortDescription('');
		    $newArticle->setAttributeSetId($attributeSetId); // Ändern, wenn man eine anderes Attribute haben möchte als default
			
			// Preis
			$_priceGross = 0;
			$articlePriceNet = str_replace(',', '.', $article->ArtikelpreisNetto);
			if($taxInclusive)
			{
				$_priceGross = (float)$articlePriceNet * (1 + ((float)$article->MwStValue / 100));
			}
			else
			{
				$_priceGross = (float)$articlePriceNet;
			}
			$newArticle->setPrice(str_replace('.',',',$_priceGross));
		    $newArticle->setSku($article->ArtikelnummerWebshop);
			$newArticle->setStatus(1);			
			
			// tax_class_id für Artikel setzen
			$taxClassId = 0;
			if ($article->MwStValue != 0)
			{
				// Ermitteln der tax_calculation_rate_id, die für das Ermitteln der tax_class_id benötigt wird
				$taxCalcRate = Mage::getModel('tax/calculation_rate')->getCollection()->toArray();
				$taxCalcRateId = 0;
				
				foreach($taxCalcRate['items'] as $taxItem)
				{
					//var_dump((int)$taxItem['tax_calculation_rate_id']);
					if ($taxItem['tax_country_id'] == 'DE' && (float)$taxItem['rate'] == number_format((float)$article->MwStValue, 4, '.', ''))
					{
						$taxCalcRateId = (int)$taxItem['tax_calculation_rate_id'];
					}
				}
				
				// Ermitteln der tax_class_id
				$taxClassId = Mage::getModel('tax/calculation')->load($taxCalcRateId)->getProductTaxClassId();				
			}
			$newArticle->setTaxClassId($taxClassId);
			
			$newArticle->setVisibility(Mage_Catalog_Model_Product_Visibility::VISIBILITY_NOT_VISIBLE);
		   	$newArticle->setName($artikelname);
			
			if($article->Gewicht != 'DSC_IGNORE')
			{
				$newArticle->setWeight(str_replace('.',',',$article->Gewicht));
			}
		    
			$newArticle->setTypeId('simple');
		    
			$newArticle->setCreatedAt(strtotime('now'));
			
			$newArticle->save();
			$articleID = $newArticle->getId();
			if($articleID > 0)
			{
				$stockItem = Mage::getModel('cataloginventory/stock_item')->loadByProduct($articleID);
					
				$stockID = $stockItem->getStockId();
				if(!$stockID)
				{
					$stockItem->setData('stock_id', 1);
				}
				else
				{
					$stockItem->setData('stock_id', $stockID);
				}
				$stockItem->setData('product_id', $articleID);
			
				$stockItem->setData('is_in_stock', 0);
				
				//$stockItem->setData('backorders', $stock->LagerWiederbeschaffungsdauer);
				$stockItem->setData('qty', 0);
				$stockItem->setData('min_qty', 0);
				$stockItem->save();	
				$amount_successfully_created++;
			}
		}
		
		WriteXMLResult($amount_articles, $amount_successfully_created);
	}
	//Hier können Sie den Export vom ERP zum Shop definieren
}


function setze_lagerbestand_im_shop()
{
	$stockValueFile = file_get_contents('php://input');
	$wholeAmount = 0;
	$successfully_created = 0;
	if($stockValueFile != null && strlen($stockValueFile) > 0)
	{
		require_once(REF_MAGE);
		Mage::app();
		
		$stockValues = simplexml_load_string(($stockValueFile));
		foreach($stockValues as $stock)
		{
			
			try
			{
				$wholeAmount = count($stockValues);
				$product = Mage::getModel('catalog/product')->loadByAttribute('sku',$stock->ArtikelnummerWebshop);
				if($product != null)
				{
					$stockItem = Mage::getModel('cataloginventory/stock_item')->loadByProduct($product->getId());
					
					$stockID = $stockItem->getStockId();
					if(!$stockID)
					{
						$stockItem->setData('stock_id', 1);
					}
					else
					{
						$stockItem->setData('stock_id', $stockID);
					}
					$stockItem->setData('product_id', $product->getId());
					if($stock->LagerBestandAktuell == 0)
					{
						$stockItem->setData('is_in_stock', 0);
					}
					else
					{
						$stockItem->setData('is_in_stock', 1);
					}
					//$stockItem->setData('backorders', $stock->LagerWiederbeschaffungsdauer);
					$stockItem->setData('qty', str_replace('.',',',$stock->LagerBestandAktuell));
					$stockItem->setData('min_qty', str_replace('.',',',$stock->LagerMindestBestand));
					$stockItem->save();	
					$successfully_created++;
				}
			}
			catch(Exception $e)
			{
				//nothing to do
			}
		}
	}
	
	WriteXMLResult($wholeAmount, $successfully_created);
	//Hier können Sie den Bestellstatusexport vom ERP zum Shop definieren
}

function hole_Artikelliste_fuer_export()
{
	require_once(REF_MAGE);
	Mage::app();
	 /** XML-Dokument erzeugen */
	$dom = new DomDocument('1.0');
	$dom->xmlStandalone = true;
	$dom->encoding="utf-8";

	/** orgaMax oberstes Knotenelement */
	$domOrders = $dom->appendChild($dom->createElement('ArtikelListeWebshop'));
	$articleList = Mage::getModel('catalog/product');
	$products = $articleList->getCollection()->addAttributeToSelect(array('sku', 'name'));

	foreach($products as $product)
	{
		$domOrder = $domOrders->appendChild($dom->createElement('row'));
		Add_NewDocElement($dom, $domOrder, 'ArtikelnummerWebshop', $product->getSku());
		Add_NewDocElement($dom, $domOrder, 'Artikelbeschreibung', $product->getName());
	}
	$dom->formatOutput = true;
	
	//XML zurück geben
	echo $dom->saveXML();
	//Hier können Sie die Artikelliste aus den Shops laden, die für den Export gebraucht werden.
}

function setze_Artikelpreise_im_shop()
{
	$articlePriceFile = file_get_contents('php://input');
	$wholeAmount = 0;
	$successfully_created = 0;
	if($articlePriceFile != null && strlen($articlePriceFile) > 0)
	{
		require_once(REF_MAGE);
		Mage::app()->setCurrentStore(Mage_Core_Model_App::ADMIN_STORE_ID);
		
		// Steuereinstellungen aus Magento ermitteln
		$taxInclusive = true;
		$coreConfigDataCollectionArray = Mage::getModel('core/config_data')->getCollection()->toArray();
		$coreConfigDataItems = $coreConfigDataCollectionArray['items'];
		foreach($coreConfigDataItems as $item)
		{
			if($item['path'] == 'tax/calculation/price_includes_tax')
			{
				$taxInclusive = ($item['value'] == 1) ? true : false;
			}
		}
			
		// Array für Steuersätze aus Magento erstellen
		// ProductClassId => TaxRate
		$_taxHelper = Mage::helper('tax');
		$taxString = preg_replace('/value_/', '', $_taxHelper->getTaxRatesByProductClass());
		$taxArray = json_decode($taxString);
		
		$articlePrices = simplexml_load_string(($articlePriceFile));
		$wholeAmount = count($articlePrices);
		foreach($articlePrices as $articlePrice)
		{
			try
			{
				$product = Mage::getModel('catalog/product')->loadByAttribute('sku',$articlePrice->ArtikelnummerWebshop);
				
				if($product != null)
				{
					// MwSt aus Produkt bestimmen
					$rateModel = Mage::getSingleton('tax/calculation_rate')->load($product->getTaxClassId());			
					$mwstValue = 0;

					foreach($taxArray as $productClass => $taxRate)
					{
						if($product->getData("tax_class_id") == (int)$productClass)
						{
							$mwstValue = $taxRate;
						}
					}
					
					// Preis je nach Shopeinstellungen
					$exportPrice = 0;
					$exportPrice = str_replace(',','.',$articlePrice->ArtikelpreisNetto);
					if($taxInclusive)
					{
						$exportPrice = (float)$exportPrice * (1 + ((float)$mwstValue / 100));
					}
					else
					{
						$exportPrice = (float)$exportPrice;
					}
					
					
					if($articlePrice->ArtikelPreisBeziehtSichAufMenge > 1)
					{
						$existingTierPrice = $product->getTierPrice();
						
						$tierPrice[0]["website_id"] = 0;
						$tierPrice[0]["all_groups"] = 1;
						$tierPrice[0]["cust_group"] = 1;
						$value = str_replace('.',',',$articlePrice->ArtikelPreisBeziehtSichAufMenge);
						$tierPrice[0]["price_qty"] = number_format($value,4,'.','');
						
						$tierPrice[0]["price"] = number_format($exportPrice,4,'.','');
						$tierPrice[0]["website_price"] = number_format($exportPrice,4,'.','');
						
						//$tierPrice = array_merge($existingTierPrice, $tierPrice);
						$product->setTierPrice($tierPrice);
						
						$product->save();
						
						unset($existingTierPrice);
						unset($tierPrice);
					}
					else
					{
						$product->setPrice($exportPrice);
						$product->save();
					}
					
					$successfully_created++;
				}
			}
			catch(Exception $e)
			{
				//nothing to do
			}
		}
		WriteXMLResult($wholeAmount, $successfully_created);
	}
	//Hier können Sie den Preislistenexport vom ERP zum Shop definieren
}

function pruefeOffeneBestellungenImShop()
{
	require_once(REF_MAGE);
	Mage::app();
	
	$ordersMag = Mage::getModel('sales/mysql4_order_collection');
	
	  /**
         * Magento Basis-Stati Verkaufauftr?ge (sales_ order_states)
         * pending
         * processing
         * complete
         * closed
         * canceled
         * holded
         */
        $status = 'pending';
        switch($GLOBALS["DEFAULT_ORDERS_STATUS"])
        {
        	case 0:
        		$status = 'pending';
        		break;
        	case 1:
        		$status = 'processing';
        		break;
        	case 2:
        		$status = 'complete';
        		break;
        	case 3:
        		$status = 'closed';
        		break;
        	case 4:
        		$status = 'canceled';
        		break;
        	case 5:
        		$status = 'holded';
        		break;
        }
        /** orgaMax Importfilter für Verkaufsaufträge */
        $ordersMag->addFieldToFilter('status',Array('eq'=>$status));

        /** Alle gefilterten Verkaufsaufträge holen */
        $colOrderIDs = $ordersMag->getAllIds();
		
		//Liefert die Anzahl der offenen Bestellungen zurück
		if(count($colOrderIDs) > 0)
		{
			echo 1;
		}
		else
		{
			echo 0;
		}
}

function artRow_ueberpruefen($artRow)
{
	return $artRow;
}

// Für orgaMAX Statusmeldung implementiert, ansonsten kam es zu Fehlinformationen
function status_aendern($orderId)
{
	try {
		// Magento Framework laden
		require_once(REF_MAGE);
        Mage::app();	
			
		// Status der Bestellung wechseln
		$state = $GLOBALS["aendern_zu"];
		$comment = 'Der Status des Verkaufsauftrag wurde vom ERP geändert.';
		$isCustomerNotified = false;
		//$tmpOrder->setState($state, $status, $comment, $isCustomerNotified);
		
		// MR: 11.01.2013
		// Bestellungen, die in den Status 'On Hold' gesetzt werden, können nun auch wieder aufgenommen werden.
		// Bestellungen, könenn nun auch direkt auf 'Complete' gesetzt werden.
		$tmpOrder = Mage::getModel('sales/order')
		  ->loadByIncrementId($orderId);
		  
		switch($state)
		{
			case 'holded':
				if($tmpOrder->canHold())
				{
					$tmpOrder->setHoldBeforeState($tmpOrder->getState());
					$tmpOrder->setHoldBeforeStatus($tmpOrder->getStatus());
					$tmpOrder->setState(Mage_Sales_Model_Order::STATE_HOLDED, true, $comment, $isCustomerNotified);
				}
				break;
			case 'pending':
				$tmpOrder->setState(Mage_Sales_Model_Order::STATE_PENDING, true, $comment, $isCustomerNotified);
				break;
			case 'complete':
				$tmpOrder->setData('state', $state)
				  ->setStatus($state)
				  ->addStatusHistoryComment($comment)
				  ->setIsCustomerNotified($isCustomerNotified);
				break;
			case 'closed':
				$tmpOrder->setState(Mage_Sales_Model_Order::STATE_CLOSED, true, $comment, $isCustomerNotified);
				break;
			default:
				break;
		}
		$tmpOrder->save();
		
	} catch (Exception $e) {
	
		die(xml_error_ausgeben($e->getMessage(), __FILE__, __FUNCTION__, __LINE__));
	}
	
	die(xml_success_ausgeben("Der Status der Bestellung '" . $orderId . "' wurde auf '" . $status . "' gesetzt."));
}

function ende()
{
	// dummy
}
//*********************************************************
// orgaMax Import-Schnittstelle Magento Ende
//*********************************************************
?>