<?PHP

//=================================================================
// Copyright (c) deltra Software GmbH
// Abfrage für Prestashop (Version 1.3.x) (c) silbersaiten
// (ab Version 1.4.8.2) (c) deltra Business Software GmbH & Co. KG
//=================================================================

$GLOBALS['VERSION_SCF'] = "4.0.00";

$presta_DateFormat = 'd.m.Y H:i:s'; // Standard aus Prestashop als Vorbelegung

function getLanguageId()
{
	$sql = '
	SELECT `value`
	FROM `' . _DB_PREFIX_ . 'configuration`
	WHERE `name` = "PS_LANG_DEFAULT" LIMIT 1';
	
	$result = mysqli_query($GLOBALS['sql_con'], $sql);
	
	return mysqli_result($result) ?: 1;
}

function daten_holen()
{
	#Querytyp:
	// datakind == 1 => Daten werden als Query verarbeitet
	// datakind == 2 => Daten werden als Array verarbeitet

	$GLOBALS['datakind'] = '1';

	$id_lang = getLanguageId();
	
	$order_state_set = implode(',', $GLOBALS['DEFAULT_ORDERS_STATUS_PRESTASHOP']);

	$GLOBALS['query'] = '
	SELECT
		orders.`id_order`            AS `orderID`                        ,
		orders.`id_order`            AS `BestellnummerShop`              ,
		orders.`date_add`            AS `Bestelldatum`                   ,
		orders.`payment`             AS `Zahlungsart`                    ,
		orders.`total_shipping_tax_excl`      AS `FrachtkostenNetto`     ,
		orders.`total_shipping_tax_incl`      AS `FrachtkostenBrutto`    ,
		orders.`total_paid_tax_incl` AS `BestellwertBrutto`				 ,
		orders.`carrier_tax_rate`    AS `FrachtkostenMwStProzent`        ,
		orders.`id_customer`         AS `KundennummerWebshop`            ,
		address.`company`            AS `Firmenname`                     ,
		address.`lastname`           AS `PersonNachname`                 ,
		address.`firstname`          AS `PersonVorname`                  ,
		address.`address1`           AS `Strasse`                        ,
		address.`postcode`           AS `Postleitzahl`                   ,
		address.`city`               AS `Ort`                            ,
		address.`phone`              AS `Telefon`                        ,
		deliveryaddress.`company`    AS `abweichendLieferungFirmenname`  ,
		deliveryaddress.`firstname`  AS `abweichendLieferungPersVorname` ,
		deliveryaddress.`lastname`   AS `abweichendLieferungPersNachname`,
		deliveryaddress.`address1`   AS `abweichendLieferungStrasse`     ,
		deliveryaddress.`postcode`   AS `abweichendLieferungPostleitzahl`,
		deliveryaddress.`city`       AS `abweichendLieferungOrt`         ,
		deliverycountry.`iso_code`   AS `abweichendLieferungLaendercode` ,
		deliverycountrylang.`name`   AS `abweichendLieferungLand`        ,
		billingaddress.`company`     AS `abweichendRechnungFirmenname`   ,
		billingaddress.`firstname`   AS `abweichendRechnungPersVorname`  ,
		billingaddress.`lastname`    AS `abweichendRechnungPersNachname` ,
		billingaddress.`address1`    AS `abweichendRechnungStrasse`      ,
		billingaddress.`postcode`    AS `abweichendRechnungPostleitzahl` ,
		billingaddress.`city`        AS `abweichendRechnungOrt`          ,
		billingcountry.`iso_code`    AS `abweichendRechnungLaendercode`  ,
		billingcountrylang.`name`    AS `abweichendRechnungLand`         ,
		products.`product_id`        AS `Positionsnummer`                ,
		products.`product_attribute_id` AS `attributeId`				 ,
		products.`product_reference` AS `ArtikelnummerShop`              ,
		products.`product_quantity`  AS `Menge`                          ,
		products.`unit_price_tax_excl` AS `abweichenderEinzelpreisNetto` ,
		products.`unit_price_tax_incl` AS `abweichenderEinzelpreisBrutto` ,
		products.`product_name` AS `abweichenderArtikeltext` ,
		product_attribute.`reference` AS `attributeReference`			 ,
		productstaxvalues.`rate`     AS `abweichendeMwStProzent`         ,
		orders.`total_discounts_tax_incl` AS `ZuschlagkostenBrutto1`     ,
		orders.`total_discounts_tax_excl` AS `ZuschlagkostenNetto1`      ,
		carrier.`name`               AS `Lieferart`                      ,
		billingcountrylang.`name`    AS `Land`                           ,
		billingcountry.`iso_code`    AS `Laendercode`                    ,
		customer.`email`             AS `Email`                          ,
		customer.`id_gender`         AS `PersonAnrede`                   ,
		GROUP_CONCAT(message.`message` ORDER BY message.`id_message` SEPARATOR "  ----  ") AS `AnmerkungenBestellung`
	
	FROM `' . _DB_PREFIX_ . 'orders` AS `orders`
	
		INNER JOIN `' . _DB_PREFIX_ . 'order_detail` AS `products`
		ON  (
				orders.`id_order` = products.`id_order`
			)
		
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'order_detail_tax` AS `productstax`
		ON	(
				products.`id_order_detail` = productstax.`id_order_detail`
			)
		
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'tax` AS `productstaxvalues`
		ON	(
				productstax.`id_tax` = productstaxvalues.`id_tax`
			)		
	
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'address` AS `address`
		ON  (
				orders.`id_address_invoice` = address.`id_address`
			)
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'address` AS `deliveryaddress`
		ON  (
				orders.`id_address_delivery` = deliveryaddress.`id_address`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'country` AS `deliverycountry`
		ON  (
				deliveryaddress.`id_country` = deliverycountry.`id_country`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'country_lang` AS `deliverycountrylang`
		ON  (
				deliveryaddress.`id_country`  = deliverycountrylang.`id_country`
			AND deliverycountrylang.`id_lang` = ' . $id_lang . '
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'address` AS `billingaddress`
		ON  (
				orders.`id_address_invoice` = billingaddress.`id_address`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'country` AS `billingcountry`
		ON  (
				billingaddress.`id_country` = billingcountry.`id_country`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'country_lang` AS `billingcountrylang`
		ON  (
				billingaddress.`id_country`  = billingcountrylang.`id_country`
			AND billingcountrylang.`id_lang` = ' . $id_lang . '
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'carrier` AS carrier
		ON  (
				orders.`id_carrier` = carrier.`id_carrier`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'customer` AS `customer`
		ON  (
				orders.`id_customer` = customer.`id_customer`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'message` AS `message`
		ON  (
				orders.`id_order` = message.`id_order`
			)
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'product_attribute` AS `product_attribute`
		ON (
				products.`product_attribute_id` = product_attribute.`id_product_attribute`
				AND (product_attribute.`reference` <> "" AND product_attribute.`reference` IS NOT NULL)
		   )
		WHERE
			orders.`id_order`
				IN (
					SELECT
						orders2.`id_order`
					FROM
						`' . _DB_PREFIX_ . 'orders` 							AS `orders2`,
						`' . _DB_PREFIX_ . 'order_history`				AS `orders_history`
					WHERE
						orders_history.`id_order_state` IN (' . $order_state_set . ')
						AND orders_history.`id_order_history` = (SELECT MAX(id_order_history) FROM ' . _DB_PREFIX_ . 'order_history WHERE id_order = orders.`id_order`)
				)
		GROUP BY
			products.`id_order_detail`,
			productstaxvalues.`id_tax`
    ';

	return $GLOBALS['datakind'];
}

function row_ueberpruefen($row)
{	
	switch (intval($row['PersonAnrede']))
	{
		case 1:
			$row['PersonAnrede'] = 'Herr';
			break;
		case 2:
			$row['PersonAnrede'] = 'Frau';
			break;
		default:
			$row['PersonAnrede'] = '';
			break;
	}

	$row['Laendercode'] = LaenderkuerzelISO2OMX($row['Laendercode']);	
	$row['abweichendRechnungLaendercode'] = LaenderkuerzelISO2OMX($row['abweichendRechnungLaendercode']);
	$row['abweichendLieferungLaendercode'] = LaenderkuerzelISO2OMX($row['abweichendLieferungLaendercode']);
    $row['ZuschlagkostenBrutto1'] = $row['ZuschlagkostenBrutto1'] * -1;
    $row['ZuschlagkostenNetto1'] = $row['ZuschlagkostenNetto1'] * -1;
    $row['abweichendeMwStProzent'] = empty($row['abweichendeMwStProzent']) ? "0.0" : $row['abweichendeMwStProzent'];

	// Variantenartikelnummer generieren
	if ($GLOBALS['attributes_import'])
	{
		if ($row['attributeId'] > 0)
		{
			$row['ArtikelnummerShop'] = generiereVariantenNummer($row['attributeId']);
		}
	}

	return $row;
}

/*
	Artikeldaten OMX -> Webshop
*/
function artikeldaten_orgamax_zu_shop() {
	$articleFile = file_get_contents('php://input');
	if($articleFile != null && strlen($articleFile) > 0) {
	
		$articles = simplexml_load_string(($articleFile));
		
		$amount_successfully_created = 0;
		$amount_articles = count($articles);
		
		foreach($articles as $article)
		{
			// Prüfen, ob Artikel im Webshop schon vorhanden ist
			$query = '
				SELECT
					id_product
				FROM
					`' . _DB_PREFIX_ . 'product`
				WHERE
					reference = "' . mysqli_real_escape_string($GLOBALS['sql_con'], $article->ArtikelnummerWebshop) . '"
			';
			$result = mysqli_query($GLOBALS['sql_con'], $query);
			$amount = mysqli_num_rows($result);
			if ($amount > 0) {
				continue;
			}
			
			// Language ID ermitteln
			$query = '
				SELECT id_lang FROM `' . _DB_PREFIX_ . 'lang` WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '"
			';
			$result = mysqli_query($GLOBALS['sql_con'], $query);
			$result = mysqli_fetch_assoc($result);
			$language_id = $result['id_lang'];
			
			// ID der Steuergruppe ermitteln
			$query = '
				SELECT
					trg.id_tax_rules_group
				FROM
				`' . _DB_PREFIX_ . 'tax_rules_group` trg
				INNER JOIN `' . _DB_PREFIX_ . 'tax_rule` tr
					ON (tr.id_tax_rules_group = trg.id_tax_rules_group)
					AND tr.id_country = (SELECT `id_country` FROM `' . _DB_PREFIX_ . 'country` WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")
				INNER JOIN `' . _DB_PREFIX_ . 'tax` tx
					ON (tx.id_tax = tr.id_tax AND tx.active = 1 AND tx.deleted = 0)
				WHERE
					(trg.active = 1 AND trg.deleted = 0) AND
					(tx.rate = '.$article->MwStValue.')
			';
			$result = mysqli_query($GLOBALS['sql_con'], $query);
			$taxgroup_id = mysqli_result($result);
			
			// ID der Artikelkategorie ermitteln
			$query = '
				SELECT
					id_category
				FROM
					`' . _DB_PREFIX_ . 'category_lang`
				WHERE
					name = "' . mysqli_real_escape_string($GLOBALS['sql_con'], $article->Artikelkategorie) . '" 
					AND id_lang = "'. $language_id . '"
			';
			$result = mysqli_query($GLOBALS['sql_con'], $query);
			$result = mysqli_fetch_assoc($result);
			$category_id = ($result['id_category']) ? $result['id_category'] : 1;
			
			// Artikelpreis auswerten und Preise umwandeln
			$articlePrice = ($article->ArtikelpreisBrutto != 'DSC_IGNORE') ? $article->ArtikelpreisBrutto : $article->ArtikelpreisNetto;
			// Zahlenwerte von , in . Notation umwandeln
			$articlePrice = str_replace(',', '.', $articlePrice);
			$article->Einkaufspreis = str_replace(',', '.', $article->Einkaufspreis);
			$article->Gewicht = str_replace(',', '.', $article->Gewicht);
			
			// Artikel weiter verarbeiten
			$query = '
				INSERT INTO
					`' . _DB_PREFIX_ . 'product` (
						id_tax_rules_group, 
						id_category_default, 
						quantity, 
						minimal_quantity, 
						price, 
						wholesale_price, 
						reference, 
						weight, 
						active,
						available_for_order,
						date_add,
						date_upd
						)
				VALUES (
					"' . $taxgroup_id . '", 
					"' . $category_id . '", 
					"1", 
					"1",
					"' . $articlePrice . '", 
					"' . $article->Einkaufspreis . '", 
					"' . mysqli_real_escape_string($GLOBALS['sql_con'], $article->ArtikelnummerWebshop) . '", 
					"' . $article->Gewicht . '", 
					"0", 
					"0",
					"' . date("Y-m-d H:i:s") . '", 
					"' . date("Y-m-d H:i:s") . '"
				)
			';	
			$result = mysqli_query($GLOBALS['sql_con'], $query);
			$product_id = mysqli_insert_id($GLOBALS['sql_con']);
			
			if(!$result) {
				continue;
			}
			
			// Aenderung fuer Prestashop 1.6.0.8
			$query = '
				INSERT INTO
					`' . _DB_PREFIX_ . 'product_shop` (
						id_product,
						id_shop,
						id_category_default,
						id_tax_rules_group,
						on_sale,
						online_only,
						ecotax,
						minimal_quantity,
						price,
						wholesale_price,
						active,
						available_for_order,
						date_add,
						date_upd,
						redirect_type
						)
				VALUES (
					"' . $product_id . '",
					"1",
					"' . $category_id . '", 
					"' . $taxgroup_id . '", 
					"0", 
					"0",
					"0",
					"1",
					"' . $articlePrice . '",
					"' . $article->Einkaufspreis . '",
					"0",
					"0",
					"' . date("Y-m-d H:i:s") . '",
					"' . date("Y-m-d H:i:s") . '",
					"404"
				)
			';
			$result = mysqli_query($GLOBALS['sql_con'], $query);
			
			if(!$result) {
				continue;
			}
			
			// Strings formatieren
			$ArtikelName = (String)$article->Artikelbeschreibung;
			$article->Anmerkungen = mb_convert_encoding($article->Anmerkungen, "HTML-ENTITIES", "UTF-8");
			$article->Artikelbeschreibung = $article->Anmerkungen = mb_convert_encoding($article->Artikelbeschreibung, "HTML-ENTITIES", "UTF-8");
			
			$query = '
				INSERT INTO
					`' . _DB_PREFIX_ . 'product_lang` (
						id_product,
						id_lang,
						description,
						description_short,
						name,
						link_rewrite
					)
				VALUES (
					"' . $product_id . '", 
					"' . $language_id . '", 
					"' . mysqli_real_escape_string($GLOBALS['sql_con'], $article->Anmerkungen) . '", 
					"' . mysqli_real_escape_string($GLOBALS['sql_con'], $article->Anmerkungen) . '", 
					"' . mysqli_real_escape_string($GLOBALS['sql_con'], $ArtikelName) . '",
					"' . mysqli_real_escape_string($GLOBALS['sql_con'], $article->ArtikelnummerWebshop) . '"
				)
			';
			$result = mysqli_query($GLOBALS['sql_con'], $query);
			
			$query = '
				INSERT INTO
					`' . _DB_PREFIX_ . 'category_product` (
						id_category,
						id_product,
						position
					)
				VALUES (
					"' . $category_id . '", 
					"' . $product_id . '", 
					"0"
				)
			';
			$result = mysqli_query($GLOBALS['sql_con'], $query);
			if ($result) {
				$amount_successfully_created++;
			}
			
		} // Artikel verarbeiten
		
		WriteXMLResult($amount_articles,$amount_successfully_created);
	} // Artikeldatei importieren hat geklappt
}

/*
	Lagerbestände aktualisieren
*/
function setze_lagerbestand_im_shop() {
	// InputStream für Datei mit Artikeln und neuen Lagerbeständen öffnen
	$articleFile = file_get_contents('php://input');

	// Anzahl Artikel und erfolgreich ersteller Artikel bereitstellen
	$amount_successfully_created = 0;
	$amount_articles = 0;
	
	// Prüfen ob Datei mit Artikeln erfolgreich bzw. überhaupt etwas übermittelt wurde
	if($articleFile != null && strlen($articleFile) > 0) {
		
		$articles = simplexml_load_string(($articleFile));
		
		$amount_articles = count($articles);

		// Wenn Artikelvarianten genutzt werden, die Pseudo-Artikelnummer vorher für alle einmal generieren
		$articleVariants = array();
		if($GLOBALS['attributes_import'])
		{
			$variantQuery = '
				SELECT
					id_product_attribute, id_product
				FROM
					' . _DB_PREFIX_ . 'product_attribute
			';

			$result = mysqli_query($GLOBALS['sql_con'], $variantQuery);
			while($data = mysqli_fetch_assoc($result))
			{
				$variant = array();
				$variant['productId'] = $data['id_product'];
				$variant['attributeId'] = $data['id_product_attribute'];
				$variant['reference'] = generiereVariantenNummer($variant['attributeId']);

				$articleVariants[] = $variant;
			}
		}
		
		foreach($articles as $article)
		{
			$articleNr =  $article->ArtikelnummerWebshop;
            $attributeID = 0;
			$product_id = -1;

            if ($GLOBALS['attributes_import'])
            {
				// id_product_attribute ermitteln
				$find_query = '
				SELECT
					id_product_attribute AS attributeId,
					' . _DB_PREFIX_ . 'product_attribute.id_product AS productId
				FROM
					' . _DB_PREFIX_ . 'product_attribute
				WHERE
					reference = "' . mysqli_real_escape_string($GLOBALS['sql_con'], $articleNr) . '"
				';

				$result = mysqli_query($GLOBALS['sql_con'], $find_query);

				if($result && mysqli_num_rows($result) == 1)
				{
					$result = mysqli_fetch_assoc($result);
					$product_id = $result['productId'];
					$attributeID = $result['attributeId'];
				}
				else
				{
					foreach($articleVariants as $variant)
					{
						if($variant['reference'] == $articleNr)
						{
							$product_id = $variant['productId'];
							$attributeID = $variant['attributeId'];
							break;
						}
					}
				}

            }

			if($product_id == -1)
            {
				$find_query = '
					SELECT
						id_product
					FROM
						`' . _DB_PREFIX_ . 'product`
					WHERE
						reference = "' . mysqli_real_escape_string($GLOBALS['sql_con'], $articleNr) . '"
				';
				$result_id = mysqli_query($GLOBALS['sql_con'], $find_query);
				$result_id = mysqli_fetch_assoc($result_id);
				$product_id = $result_id['id_product'];
            }

			if ($product_id > -1)
			{
				// ArtikelMenge einfügen oder aktualisieren
				$find_query = '
				SELECT
					id_product
				FROM
					`' . _DB_PREFIX_ . 'stock_available`
				WHERE
					id_product = ' . $product_id . '
				';

				$result_count = mysqli_query($GLOBALS['sql_con'], $find_query);

				if (mysqli_num_rows($result_count) > 0)
				{
					$query = '
                    UPDATE
                        `' . _DB_PREFIX_ . 'stock_available`
                    SET
                        quantity = "' . str_replace(',', '.', $article->LagerBestandAktuell) . '"
                    WHERE
                        id_product = "' . $product_id . '"
                        AND id_product_attribute = ' . $attributeID . '
                    ';
				}
				else
				{
					$query = '
                    INSERT INTO
                        `' . _DB_PREFIX_ . 'stock_available` (id_product, id_product_attribute, id_shop, id_shop_group, quantity, depends_on_stock, out_of_stock)
                    VALUES
                        (' . $product_id .', ' . $attributeID . ', 1, 0, ' . str_replace(',', '.', $article->LagerBestandAktuell) . ', 0, 2)
                    ';
				}

				$result = mysqli_query($GLOBALS['sql_con'], $query);

				if($result)
				{
					$amount_successfully_created++;
				}
			}
		}
		
	}
	WriteXMLResult($amount_articles, $amount_successfully_created);
	//Hier können Sie den Bestellstatusexport vom ERP zum Shop definieren
}


/*
	Prüfen, ob noch offene Bestellungen im Shop vorhanden sind.
	Wird für Lagerbestandsaktualisierung benötigt.
*/
function pruefeOffeneBestellungenImShop() {
	// Menge der Stati für Datenbank Statement vorbereiten
	$order_state_set = implode(',', $GLOBALS['DEFAULT_ORDERS_STATUS_PRESTASHOP']);
	
	// Anzahl offene Bestellungen ermitteln
	$openedOrders = 0;

	$query = '
		SELECT
			COUNT(orders.`id_order`)									AS `AnzahlOffeneBestellungen`
		FROM
			`' . _DB_PREFIX_ . 'orders` 							AS `orders`,
			`' . _DB_PREFIX_ . 'order_history`				AS `orders_history`
		WHERE
			orders_history.`id_order_state` IN (' . $order_state_set . ')
			AND orders_history.`id_order_history` = (SELECT MAX(id_order_history) FROM ' . _DB_PREFIX_ . 'order_history WHERE id_order = orders.`id_order`)
	';
	$result = mysqli_query($GLOBALS['sql_con'], $query);
	if (!is_null($result)) {
		$result = mysqli_fetch_assoc($result);
	}
	
	$openedOrders = $result['AnzahlOffeneBestellungen'];
	
	echo $openedOrders;
}

/*
	Artikelliste zum Abgleich bereitstellen
*/
function hole_Artikelliste_fuer_export() 
{
	$query = "";
	if ($GLOBALS['attributes_import'])
	{
		$query = '
		SELECT
			products.`id_product`              			AS `productID`           	,
			products.`reference`               			AS `ArtikelnummerWebshop`	,
			products_description.`name`        			AS `Artikelbeschreibung` 	,
			products_description.`description` 			AS `Anmerkungen`         	,
			products_tax.`rate`   			   			AS `MwStValue` 				,
			products.`weight`                  			AS `Gewicht`             	,
			products.`price`                   			AS `ArtikelpreisNetto`   	,
			product_attributes.`id_product_attribute`	AS `Var_ID`					,
			product_attributes.`reference`	   			AS `Var_SKU`				,
			stock_available.`quantity` 					AS `Var_Lagerbestand` 		,
			product_attributes.`price`					AS `Var_Preis`				,
			product_attributes.`weight`					AS `Var_Gewicht`
		FROM `' . _DB_PREFIX_ . 'product`                				AS `products`		
		INNER JOIN `' . _DB_PREFIX_ . 'product_lang` AS `products_description`
		ON  (
				products.`id_product`          = products_description.`id_product`
				AND products_description.`id_lang` = (SELECT id_lang FROM ' . _DB_PREFIX_ . 'lang WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")
			)
		LEFT JOIN `' . _DB_PREFIX_ . 'product_attribute` 				AS `product_attributes`
		ON  (
				products.`id_product` = product_attributes.`id_product`
			)
		LEFT JOIN `' . _DB_PREFIX_ . 'stock_available` AS `stock_available`
		ON (
			product_attributes.id_product = stock_available.id_product AND
			product_attributes.id_product_attribute = stock_available.id_product_attribute
		)
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'tax_rule` 					AS `products_tax_rule`
		ON	(
				products.`id_tax_rules_group` = products_tax_rule.`id_tax_rules_group`
			)
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'tax` 						AS `products_tax`
		ON	(
				products_tax_rule.`id_tax` = products_tax.`id_tax`
			)
		WHERE
			products.`reference` <> "" 
		AND products.`reference` IS NOT NULL
		AND	products_tax_rule.`id_country` = (SELECT `id_country` FROM `' . _DB_PREFIX_ . 'country` WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")
		OR products.`id_tax_rules_group` = 0
		ORDER BY
			products.`id_product`
		';
			}
	else
	{
		$query = '
		SELECT
			products.`reference`								AS ArtikelnummerWebshop,
			products_lang.`description`					AS Artikelbeschreibung,
			products_lang.`description_short`		AS Kurzbeschreibung,
			products_lang.`name`								AS Artikelname
		FROM
			`' . _DB_PREFIX_ . 'product` AS `products`,
			`' . _DB_PREFIX_ . 'product_lang` AS `products_lang`
		WHERE
			products.`id_product` = products_lang.`id_product`
			AND products_lang.`id_lang` = (SELECT id_lang FROM ' . _DB_PREFIX_ . 'lang WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")';
	}
	
	/** XML-Dokument erzeugen */
	$dom = new DomDocument('1.0');
	$dom->xmlStandalone = true;
	$dom->encoding="utf-8";
	
    $domArticles = $dom->appendChild($dom->createElement('ArtikelListeWebshop'));
	$result = mysqli_query($GLOBALS['sql_con'], $query);
	
	if(mysqli_num_rows($result) > 0)
	{
		while($article = mysqli_fetch_assoc($result))
		{
			$articleNumber = $article['ArtikelnummerWebshop'];
			if ($GLOBALS['attributes_import'])
			{
				if(!empty($article['Var_ID']))
				{
					$articleNumber = generiereVariantenNummer($article['Var_ID']);
				}
			}
			
			$domArticle = $domArticles->appendChild($dom->createElement('row'));
			Add_NewDocElement($dom, $domArticle, 'ArtikelnummerWebshop', $articleNumber);
			Add_NewDocElement($dom, $domArticle, 'Artikelbeschreibung', $article['Artikelbeschreibung']);
		}
	}
	 $dom->formatOutput = true;
     echo $dom->saveXML();
}

/*
	Artikelpreise zu ausgewählten Artikeln setzen.
*/
function setze_Artikelpreise_im_shop()
{
	$articleFile = file_get_contents('php://input');
	if($articleFile != null && strlen($articleFile) > 0) {
	
		$articles = simplexml_load_string(($articleFile));
		
		$amount_successfully_created = 0;
		$amount_articles = count($articles);

		// Wenn Artikelvarianten genutzt werden, die Pseudo-Artikelnummer vorher für alle einmal generieren
		$articleVariants = array();
		if($GLOBALS['attributes_import'])
		{
			$variantQuery = '
				SELECT
					id_product_attribute, id_product
				FROM
					' . _DB_PREFIX_ . 'product_attribute
			';

			$result = mysqli_query($GLOBALS['sql_con'], $variantQuery);
			while($data = mysqli_fetch_assoc($result))
			{
				$variant = array();
				$variant['productId'] = $data['id_product'];
				$variant['attributeId'] = $data['id_product_attribute'];
				$variant['reference'] = generiereVariantenNummer($variant['attributeId']);

				$articleVariants[] = $variant;
			}
		}
		
		foreach($articles as $article)
		{
			$Preis = 0.0;
			$articleNr =  $article->ArtikelnummerWebshop;
			$variantFound = false;

			if($article->ArtikelpreisNetto != 'DSC_IGNORE')
			{
				$Preis = str_replace(',','.',$article->ArtikelpreisNetto);
			}
			else
			{
				$Preis = str_replace(',','.',$article->ArtikelpreisBrutto);
			}
			if($article->ArtikelPreisBeziehtSichAufMenge == 1)
			{
				if ($GLOBALS['attributes_import'])
				{
					$product_id = -1;
					$attributeID = 0;

					// id_product_attribute ermitteln
					$find_query = '
					SELECT
						id_product_attribute AS attributeId,
						' . _DB_PREFIX_ . 'product_attribute.id_product AS productId
					FROM
						' . _DB_PREFIX_ . 'product_attribute
					WHERE
						reference = "' . $articleNr . '"
					';

					$result = mysqli_query($GLOBALS['sql_con'], $find_query);

					if($result && mysqli_num_rows($result) == 1)
					{
						$result = mysqli_fetch_assoc($result);
						$product_id = $result['productId'];
						$attributeID = $result['attributeId'];
					}
					else
					{
						foreach($articleVariants as $variant)
						{
							if($variant['reference'] == $articleNr)
							{
								$product_id = $variant['productId'];
								$attributeID = $variant['attributeId'];
								break;
							}
						}
					}

					if($product_id > -1)
					{
						$variantFound = true;

						$priceQuery = '
						SELECT
							price
						FROM
							' . _DB_PREFIX_ . 'product_shop
						WHERE
							id_product = ' . $product_id . '
						';

						$result_price = mysqli_query($GLOBALS['sql_con'], $priceQuery);
						$result_price = mysqli_fetch_assoc($result_price);
						$variantPrice = $Preis - $result_price['price'];

						$query = '
						UPDATE
							' . _DB_PREFIX_ . 'product_attribute
						SET
							price = ' . $variantPrice . '
						WHERE
							id_product_attribute = ' . $attributeID . '
						';

						$result = mysqli_query($GLOBALS['sql_con'], $query);

						if($result)
						{
							$query = '
							UPDATE
								' . _DB_PREFIX_ . 'product_attribute_shop
							SET
								price = ' . $variantPrice . '
							WHERE
								id_product_attribute = ' . $attributeID . '
							';

							$result = mysqli_query($GLOBALS['sql_con'], $query);

							if($result)
							{
								$amount_successfully_created++;
							}
						}
					}
				}

				if(!$variantFound)
				{
					$query = '
						UPDATE
							`' . _DB_PREFIX_ . 'product`
						SET
							price = "' . $Preis . '"
						WHERE
							reference = "' . $articleNr . '"
					';
					$result = mysqli_query($GLOBALS['sql_con'], $query);

					if(!$result)
					{
						continue;
					}

					$query = '
						SELECT
							id_product
						FROM
							`' . _DB_PREFIX_ . 'product`
						WHERE
							reference = "' . $articleNr . '"
					';
					$result_id = mysqli_query($GLOBALS['sql_con'], $query);
					$result_id = mysqli_fetch_assoc($result_id);
					$product_id = $result_id['id_product'];

					$query = '
						UPDATE
							`' . _DB_PREFIX_ . 'product_shop`
						SET
							price = "' . $Preis . '"
						WHERE
							id_product = ' . $product_id . '
					';

					$result = mysqli_query($GLOBALS['sql_con'], $query);
					if($result)
					{
						$amount_successfully_created++;
					}
				}
			}
		}
		WriteXMLResult($amount_articles,$amount_successfully_created);
	}
	//Funktion wird von veyton nicht untersützt (Staffelpreis)
}

/*
	Artikeldaten Webshop -> OMX
*/
function artikeldaten_shop_zu_orgamax()
{
	// Daten werden als Query übergeben
	$GLOBALS['datakind'] = '1';
	
	// Pagination
	$limit = (int)$_GET['limit'] ?: 0;
	$offset = (int)$_GET['offset'] ?: 0;
	
    if ($GLOBALS['attributes_import'])
    {
        $GLOBALS['query'] = '
		SELECT
			products.`id_product`              			AS `productID`           	,
			products.`reference`               			AS `ArtikelnummerWebshop`	,
			products_description.`name`        			AS `Artikelbeschreibung` 	,
			products_description.`description` 			AS `Anmerkungen`         	,
			products_tax.`rate`   			   			AS `MwStValue` 				,
			products.`weight`                  			AS `Gewicht`             	,
			products.`price`                   			AS `ArtikelpreisNetto`   	,
			product_attributes.`id_product_attribute`	AS `Var_ID`					,
			product_attributes.`reference`	   			AS `Var_SKU`				,
			stock_available.`quantity`					AS `Var_Lagerbestand` 		,
			product_attributes.`price`					AS `Var_Preis`				,
			product_attributes.`weight`					AS `Var_Gewicht`
		FROM `' . _DB_PREFIX_ . 'product`                				AS `products`		
		INNER JOIN `' . _DB_PREFIX_ . 'product_lang` AS `products_description`
		ON  (
				products.`id_product`          = products_description.`id_product`
				AND products_description.`id_lang` = (SELECT id_lang FROM ' . _DB_PREFIX_ . 'lang WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")
			)
		LEFT JOIN `' . _DB_PREFIX_ . 'product_attribute` 				AS `product_attributes`
		ON  (
				products.`id_product` = product_attributes.`id_product`
			)
		LEFT JOIN `' . _DB_PREFIX_ . 'stock_available` AS `stock_available`
		ON (
			product_attributes.id_product = stock_available.id_product AND
			product_attributes.id_product_attribute = stock_available.id_product_attribute
		)
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'tax_rule` 					AS `products_tax_rule`
		ON	(
				products.`id_tax_rules_group` = products_tax_rule.`id_tax_rules_group`
			)
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'tax` 						AS `products_tax`
		ON	(
				products_tax_rule.`id_tax` = products_tax.`id_tax`
			)
		WHERE
			products.`reference` <> "" 
		AND products.`reference` IS NOT NULL
		AND	products_tax_rule.`id_country` = (SELECT `id_country` FROM `' . _DB_PREFIX_ . 'country` WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")
		OR products.`id_tax_rules_group` = 0
		ORDER BY
			products.`id_product`
		';
	}
	else
	{
		$GLOBALS['query'] = '
		SELECT
			products.`id_product`              AS `productID`           ,
			products.`reference`               AS `ArtikelnummerWebshop`,
			products_description.`name`        AS `Artikelbeschreibung` ,
			products_description.`description` AS `Anmerkungen`         ,
			products_tax.`rate`   			   AS `MwStValue` 			,
			products.`weight`                  AS `Gewicht`             ,
			products.`price`                   AS `ArtikelpreisNetto`
		FROM `' . _DB_PREFIX_ . 'product`                AS `products`
		    INNER JOIN `' . _DB_PREFIX_ . 'product_lang` AS `products_description`
			ON  (
				products.`id_product`          = products_description.`id_product`
				AND products_description.`id_lang` = (SELECT id_lang FROM ' . _DB_PREFIX_ . 'lang WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")
				)
			LEFT OUTER JOIN `' . _DB_PREFIX_ . 'tax_rule` AS `products_tax_rule`
			ON	(
					products.`id_tax_rules_group` = products_tax_rule.`id_tax_rules_group`
				)
			LEFT OUTER JOIN `' . _DB_PREFIX_ . 'tax` AS `products_tax`
			ON	(
					products_tax_rule.`id_tax` = products_tax.`id_tax`
				)
		WHERE
		    products_tax_rule.`id_country` = (SELECT `id_country` FROM `' . _DB_PREFIX_ . 'country` WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")
		    OR products.`id_tax_rules_group` = 0
		ORDER BY
			products.`id_product`';
	} // Wenn keine Attribute importiert werden sollen
	
	if ($limit > 0) $GLOBALS['query'] .= " LIMIT $limit OFFSET $offset";
	
	return $GLOBALS['datakind'];
}// artikeldaten_shop_zu_orgamax

function artRow_ueberpruefen($artRow)
{	
	// Prüfen der MwSt und umbauen des MwStCode
	$artRow['MwStValue'] = (!is_null($artRow['MwStValue'])) ? $artRow['MwStValue'] : "0";
	$truncpos = strpos($artRow['MwStValue'], '.');
	$mwst_value = mb_substr($artRow['MwStValue'], 0, $truncpos);
	switch($mwst_value) {
		case 0:
			$artRow['MwStCode'] = "0";
			break;
		
		case 5:
			$artRow['MwStCode'] = "2";
			break;
		
		case 7:
			$artRow['MwStCode'] = "2";
			break;
		
		case 16:
			$artRow['MwStCode'] = "1";
			break;
		
		case 19:
			$artRow['MwStCode'] = "1";
			break;
			
		default: // Artikel werden standardmässig mit 19% MwSt importiert
			$artRow['MwStCode'] = "1";
			break;
	}

	// Artikelkategorie hinzufügen
	$artRow["Artikelkategorie"] = '';
	
	$query = '
	SELECT categories_description.`name`                AS Artikelkategorie
	FROM `' . _DB_PREFIX_ . 'category_product`        AS products_to_categories
	
		INNER JOIN `' . _DB_PREFIX_ . 'category_lang` AS categories_description
		ON  (
				products_to_categories.`id_category` = categories_description.`id_category`
			AND categories_description.id_lang     = ' . intval($GLOBALS['articles_language']) . '
			)
			
	WHERE products_to_categories.id_product  = ' . intval($artRow['productID']) . '
	AND   products_to_categories.id_category <> 0';
	
	$qRes = mysqli_query($GLOBALS['sql_con'], $query);
	
	if ($qRes)
	{
		while ($qRow = mysqli_fetch_assoc($qRes))
		{
			$artRow['Artikelkategorie'].= preg_replace('/^[0-9]+\./', '', $qRow['Artikelkategorie']) . ';';
		}
		
		$artRow['Artikelkategorie'] = rtrim($artRow['Artikelkategorie'], ';');
	}
	
	if ($GLOBALS['attributes_import'])
	{		
		// Zusätzliche Informationen zu Variante holen und zusammenführen
		$variantInfo = array();
		
		if ($artRow['Var_ID'] > 0)
		{
			// Zugehörige Informationen zu Attributen, welche in Variante genutzt werden, holen
			$query = '
			SELECT
				product_attributes.`id_attribute`		AS	`Var_AttributeId`		,
				attribute.`id_attribute_group`			AS	`Var_AttributeGroupId`	,
				attribute_lang.`name`					AS	`Var_AttributeName`		,
				attribute_group_lang.`name`				AS	`Var_AttributeGroupName`
			FROM
				' . _DB_PREFIX_ . 'product_attribute_combination		AS	`product_attributes`
			LEFT JOIN ' . _DB_PREFIX_ . 'attribute						AS	`attribute`
			ON 	(
					attribute.`id_attribute` = product_attributes.`id_attribute`
				)
			LEFT JOIN ' . _DB_PREFIX_ . 'attribute_lang				AS	`attribute_lang`
			ON 	(
					attribute_lang.`id_attribute` = product_attributes.`id_attribute`
					AND attribute_lang.`id_lang` = ' . intval($GLOBALS['articles_language']) . '
				)
			LEFT JOIN ' . _DB_PREFIX_ . 'attribute_group_lang			AS	`attribute_group_lang`
			ON	(
					attribute_group_lang.`id_attribute_group` = attribute.`id_attribute_group`
					AND attribute_group_lang.`id_lang` = ' . intval($GLOBALS['articles_language']) . '
				)
			WHERE product_attributes.`id_product_attribute` = ' . $artRow['Var_ID'] . '
			';
			
			$result = mysqli_query($GLOBALS['sql_con'], $query);
			
			// Bei MySQL Fehler Skript abbrechen
			if (mysqli_errno($GLOBALS['sql_con']) > 0)
			{
				die(xml_error_ausgeben(mysqli_error($GLOBALS['sql_con']), __FILE__, __FUNCTION__, __LINE__));
			}
			
			while($data = mysqli_fetch_assoc($result))
			{
				$variantInfo[] = $data;
			}
		}
		
		if ($artRow['Var_Gewicht'] < 0)
		{
			$artRow['Var_Gewicht']*= -1;
			$prefixWeight = '-';
		}
		else
		{
			$prefixWeight = '+';
		}

		$artRow['Var_Gewicht_Praefix'] = $prefixWeight;
		
		// Artikelnummer im Webshop
		$isEqualAttributeNumber = false;
		if (strlen($artRow['Var_SKU']) > 0)
		{
			if($artRow['ArtikelnummerWebshop'] != $artRow['Var_SKU'])
			{
				$query = '
				SELECT
					reference
				FROM
					'. _DB_PREFIX_ .'product_attribute
				WHERE
					reference = "'. mysqli_real_escape_string($GLOBALS['sql_con'], $artRow['Var_SKU']) .'"
					AND id_product = '. intval($artRow['productID']) .'
				';

				$result = mysqli_query($GLOBALS['sql_con'], $query);
				$resultCount = mysqli_num_rows($result);

				if($resultCount > 1)
				{
					$isEqualAttributeNumber = true;
				}

				$artRow['ArtikelnummerWebshop'] = $artRow['Var_SKU'];
			}
			else
			{
				$isEqualAttributeNumber = true;
			}
		}
		else
		{
			$isEqualAttributeNumber = true;
		}
		
		// Namen und Beschreibung der Varianten-Attribute an die Artikelbeschreibung anfügen
		foreach($variantInfo as $variantData)
		{
			// set article attribute number
			if($isEqualAttributeNumber)
			{
				$artRow['ArtikelnummerWebshop'] .= '-'.$variantData['Var_AttributeName'];
			}
			
			if (!empty($variantData['Var_AttributeName'])) 
			{
				$artRow['Artikelbeschreibung'] .= ' - ' . $variantData['Var_AttributeGroupName'] . ': ' . $variantData['Var_AttributeName'];
			}
		}

		if (floatval($artRow['Var_Gewicht']) <> 0)
		{
			$artRow['Gewicht'] = sprintf('%d %s %d', $artRow['Gewicht'], $artRow['Var_Gewicht_Praefix'], $artRow['Var_Gewicht']);
		}
		
		if (floatval($artRow['Var_Preis']) <> 0)
		{
			$artRow['ArtikelpreisNetto'] = (double)($artRow['ArtikelpreisNetto'] + $artRow['Var_Preis']);
		}
	}

	// Beschreibung formatieren
	$fmtArtikelbeschreibung = mb_convert_encoding($artRow['Artikelbeschreibung'], "UTF-8", "HTML-ENTITIES");
	if (mb_detect_encoding($artRow['Artikelbeschreibung'], "ASCII", true)) {
		$artRow['Artikelbeschreibung'] = $fmtArtikelbeschreibung;
	}
	$fmtAnmerkungen = mb_convert_encoding($artRow['Anmerkungen'], "UTF-8", "HTML-ENTITIES");
	if (mb_detect_encoding($artRow['Anmerkungen'], "ASCII", true)) {
		$artRow['Anmerkungen'] = $fmtAnmerkungen;
	}

	return $artRow;
}

function status_aendern($orderId)
{
	include_once "inc/config.php";
	$ShopStatus = $GLOBALS["aendern_zu"];
	
	// Letzte History Id ermitteln
	$query = '
		SELECT
			MAX(id_order_history)			AS `HistoryId`
		FROM
			' . _DB_PREFIX_ . 'order_history 
		WHERE
			id_order = ' . $orderId . '
		';
	
	$result = mysqli_query($GLOBALS['sql_con'], $query);
	$result = mysqli_fetch_assoc($result);
	$max_history_id = $result['HistoryId'];
	
	// Bestellstatus zu Bestell Id ermitteln
	$query = '
		SELECT
			id_order_state		AS `Bestellstatus`,
			id_employee				AS `MitarbeiterId`
		FROM
			`' . _DB_PREFIX_ . 'order_history` 					AS `orders_history`
		WHERE
			id_order_history = ' . $max_history_id .'
		';

	$qRes = mysqli_query($GLOBALS['sql_con'], $query);
	if ($qRes)
	{
		$row = mysqli_fetch_assoc($qRes);
		if ($row['Bestellstatus'] != $ShopStatus)
		{			
			$query = '
				INSERT INTO
					`' . _DB_PREFIX_ . 'order_history`
					(id_employee, id_order, id_order_state, date_add)
				VALUES
					(' . $row["MitarbeiterId"] . ', ' . $orderId . ', ' . $ShopStatus . ', "' . date("Y-m-d H:i:s") . '")
			';
			
			mysqli_query($GLOBALS['sql_con'], $query);
			$error = mysqli_error($GLOBALS['sql_con']);

			if ($error == '')
			{
				$query = '
					UPDATE
						`' . _DB_PREFIX_ . 'orders`
					SET
						`current_state` = ' . $ShopStatus . '
					WHERE
						`id_order` = ' . $orderId . '
					;
				';
				
				mysqli_query($GLOBALS['sql_con'], $query);
				$error = mysqli_error($GLOBALS['sql_con']);
			}

			if ($error != '')
			{
				die(xml_error_ausgeben("Bei der Statusänderung der Bestellung '$orderId' auf den Wert '$ShopStatus' trat ein Fehler auf. Beim ersten Query meldete MySql '$error'.", __FILE__, __FUNCTION__, __LINE__));
			}

			die(xml_success_ausgeben("Der Status der Bestellung '" . $orderId . "' wurde auf '" . $ShopStatus . "' gesetzt."));
		} // Der aktuelle status ist != 3
		else 
		{
			die(xml_success_ausgeben("Der Status der Bestellung '" . $orderId . "' durfte nicht geändert werden, da er bereits den Wert '" . $ShopStatus . "' besitzt."));
		}
	} // Select query war erfolgreich
	else 
	{
		die(xml_error_ausgeben("Der Datensatz mit der Bestellnummer '" . $orderId . "' konnte nicht ermittelt werden.", __FILE__, __FUNCTION__, __LINE__));
	}
}

function generiereVariantenNummer($variantenId)
{

	// Zus�tzliche Informationen zu Variante holen und zusammenf�hren
	$variantInfo = array();

	// Zugeh�rige Informationen zu Attributen, welche in Variante genutzt werden, holen
	$query = '
	SELECT
		attribute_lang.`name`					AS	`Var_AttributeName`		,
		attribute_group_lang.`name`				AS	`Var_AttributeGroupName`
	FROM
		' . _DB_PREFIX_ . 'product_attribute_combination		AS	`product_attributes`
	LEFT JOIN ' . _DB_PREFIX_ . 'attribute						AS	`attribute`
	ON 	(
			attribute.`id_attribute` = product_attributes.`id_attribute`
		)
	LEFT JOIN ' . _DB_PREFIX_ . 'attribute_lang				AS	`attribute_lang`
	ON 	(
			attribute_lang.`id_attribute` = product_attributes.`id_attribute`
			AND attribute_lang.`id_lang` = ' . intval($GLOBALS['articles_language']) . '
		)
	LEFT JOIN ' . _DB_PREFIX_ . 'attribute_group_lang			AS	`attribute_group_lang`
	ON	(
			attribute_group_lang.`id_attribute_group` = attribute.`id_attribute_group`
			AND attribute_group_lang.`id_lang` = ' . intval($GLOBALS['articles_language']) . '
		)
	WHERE 	product_attributes.`id_product_attribute` = ' . $variantenId . '
	';

	$result = mysqli_query($GLOBALS['sql_con'], $query);

	// Bei MySQL Fehler Skript abbrechen
	if (mysqli_errno($GLOBALS['sql_con']) > 0)
	{
		die(xml_error_ausgeben(mysqli_error($GLOBALS['sql_con']), __FILE__, __FUNCTION__, __LINE__));
	}

	while($data = mysqli_fetch_assoc($result))
	{
		$variantInfo[] = $data;
	}

	$query = '
	SELECT
		variant.reference		AS Var_Reference	,
		variant.id_product		AS ProductId		,
		product.reference		AS Reference
	FROM
		'. _DB_PREFIX_ .'product_attribute AS variant
	INNER JOIN
		'. _DB_PREFIX_ .'product AS product
	ON (
		variant.id_product = product.id_product
	   )
	WHERE
		variant.id_product_attribute = '. intval($variantenId) .'
	';

	$variantDetail = mysqli_query($GLOBALS['sql_con'], $query);
	$variantDetail = mysqli_fetch_assoc($variantDetail);

	$isEqualAttributeNumber = false;
	if(!empty($variantDetail['Var_Reference']))
	{
		if($variantDetail['Var_Reference'] != $variantDetail['Reference'])
		{
			$query = '
			SELECT
				reference
			FROM
				'. _DB_PREFIX_ .'product_attribute
			WHERE
				reference = "'. mysqli_real_escape_string($GLOBALS['sql_con'], $variantDetail['Var_Reference']) .'"
				AND id_product = '. intval($variantDetail['ProductId']) .'
			';

			$result = mysqli_query($GLOBALS['sql_con'], $query);
			$resultCount = mysqli_num_rows($result);

			if($resultCount > 1)
			{
				$isEqualAttributeNumber = true;
			}

			$variantDetail['Reference'] = $variantDetail['Var_Reference'];
		}
		else
		{
			$isEqualAttributeNumber = true;
		}
	}
	else
	{
		$isEqualAttributeNumber = true;
	}

	// Namen und Beschreibung der Varianten-Attribute an die Artikelbeschreibung anf�gen
	foreach($variantInfo as $variantData)
	{
		if($isEqualAttributeNumber)
		{
			$variantDetail['Reference'] .= '-'.$variantData['Var_AttributeName'];
		}
	}

	return $variantDetail['Reference'];
}

function paging_informationen()
{
	$selectQuery = null;

	if ($GLOBALS['attributes_import'])
	{
		$selectQuery = '
		SELECT
			1
		FROM `' . _DB_PREFIX_ . 'product` AS `products`
		INNER JOIN `' . _DB_PREFIX_ . 'product_lang` AS `products_description`
		ON  (
				products.`id_product`          = products_description.`id_product`
				AND products_description.`id_lang` = (SELECT id_lang FROM ' . _DB_PREFIX_ . 'lang WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")
			)
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'tax_rule` 					AS `products_tax_rule`
		ON	(
				products.`id_tax_rules_group` = products_tax_rule.`id_tax_rules_group`
			)
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'tax` 						AS `products_tax`
		ON	(
				products_tax_rule.`id_tax` = products_tax.`id_tax`
			)
		LEFT JOIN `' . _DB_PREFIX_ . 'product_attribute` AS `product_attributes`
		ON  (
				products.`id_product` = product_attributes.`id_product`
			)
		WHERE
			products.`reference` <> "" 
			AND products.`reference` IS NOT NULL
			AND	products_tax_rule.`id_country` = (SELECT `id_country` FROM `' . _DB_PREFIX_ . 'country` WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")
			OR products.`id_tax_rules_group` = 0';
	}
	else
	{
		$selectQuery = '
		SELECT
			1
		FROM `' . _DB_PREFIX_ . 'product` AS `products`
		INNER JOIN `' . _DB_PREFIX_ . 'product_lang` AS `products_description`
		ON  (
			products.`id_product`          = products_description.`id_product`
			AND products_description.`id_lang` = (SELECT id_lang FROM ' . _DB_PREFIX_ . 'lang WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")
			)
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'tax_rule` AS `products_tax_rule`
		ON	(
				products.`id_tax_rules_group` = products_tax_rule.`id_tax_rules_group`
			)
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'tax` AS `products_tax`
		ON	(
				products_tax_rule.`id_tax` = products_tax.`id_tax`
			)

		WHERE
		    products_tax_rule.`id_country` = (SELECT `id_country` FROM `' . _DB_PREFIX_ . 'country` WHERE `iso_code` = "' . $GLOBALS['ISO_CODE'] . '")
		    OR products.`id_tax_rules_group` = 0';
	}

	// Count-Query
	$selectQuery = "SELECT COUNT(*) FROM (".$selectQuery.") counttable";

	/** XML-Dokument erzeugen */
	$dom = new DomDocument('1.0');
	$dom->xmlStandalone = true;
	$dom->encoding = "utf-8";

	$infoNode = $dom->appendChild($dom->createElement('PagingInformations'));
	$result = mysqli_query($GLOBALS['sql_con'], $selectQuery);

	if (mysqli_num_rows($result) > 0)
	{
		Add_NewDocElement($dom, $infoNode, 'ArticleCount', mysqli_result($result));
	}

	$dom->formatOutput = true;
	echo $dom->saveXML();
}

function starten()
{
	if (file_exists(ORGAMAX_PS_CONFIG)) {
		$contentType = reset(preg_grep("~^Content-Type:~", headers_list()));

		include ORGAMAX_PS_CONFIG;

		// Header zurücksetzen - Wurde durch config ggfs. überschrieben
		header($contentType);
		
		$dbServer = explode(":", _DB_SERVER_);
		$GLOBALS['sql_con'] = mysqli_connect(array_shift($dbServer), _DB_USER_, _DB_PASSWD_);
		
		mysqli_select_db($GLOBALS['sql_con'], _DB_NAME_);
	}
	else
	{
		die(xml_error_ausgeben($GLOBALS['err_msg']['shop_cfg'],__FILE__, __FUNCTION__, __LINE__));
	}

	$charset = mysqli_character_set_name($GLOBALS['sql_con']);
	if($charset != 'utf8')
	{
		mysqli_set_charset($GLOBALS['sql_con'], 'utf8');
	}
}

function ende()
{
	mysqli_close($GLOBALS['sql_con']);
}

?>