<?PHP
/***************************************************************************\
*
*	Copyright (c) 2013 deltra Buisness Software GmbH & Co. KG
*	http://www.deltra.de
*
\***************************************************************************/

//=================================================================
// Abfrage für Prestashop (Version 1.3.x) (c) silbersaiten
//=================================================================

$GLOBALS['VERSION_SCF'] = "4.0.00";

function getLanguageId()
{
	$sql = '
	SELECT `value`
	FROM `' . _DB_PREFIX_ . 'configuration`
	WHERE `name` = "PS_LANG_DEFAULT" LIMIT 1';
	
	$result = mysqli_query($GLOBALS['sql_con'], $sql);
	
	if (is_array($tmp = mysqli_fetch_assoc($result)))
		return array_shift($tmp);
	
	return false;
}

function daten_holen()
{
	#Querytyp:

	// datakind == 1 => Daten werden als Query verarbeitet
	// datakind == 2 => Daten werden als Array verarbeitet

	$GLOBALS['datakind'] = '1';

	$id_lang = getLanguageId();

	$GLOBALS['query'] = '
	SELECT
		orders.`id_order`            AS `orderID`                        ,
		orders.`id_order`            AS `BestellnummerShop`              ,
		orders.`date_add`            AS `Bestelldatum`                   ,
		orders.`payment`             AS `Zahlungsart`                    ,
		orders.`total_shipping`      AS `FrachtkostenBrutto`             ,
		orders.`id_customer`         AS `KundennummerWebshop`            ,
		address.`company`            AS `Firmenname`                     ,
		address.`lastname`           AS `PersonNachname`                 ,
		address.`firstname`          AS `PersonVorname`                  ,
		address.`address1`           AS `Strasse`                        ,
		address.`postcode`           AS `Postleitzahl`                   ,
		address.`city`               AS `Ort`                            ,
		address.`phone`              AS `Telefon`                        ,
		deliveryaddress.`company`    AS `abweichendLieferungFirmenname`  ,
		deliveryaddress.`firstname`  AS `abweichendLieferungPersVorname` ,
		deliveryaddress.`lastname`   AS `abweichendLieferungPersNachname`,
		deliveryaddress.`address1`   AS `abweichendLieferungStrasse`     ,
		deliveryaddress.`postcode`   AS `abweichendLieferungPostleitzahl`,
		deliveryaddress.`city`       AS `abweichendLieferungOrt`         ,
		deliverycountry.`iso_code`   AS `abweichendLieferungLaendercode` ,
		deliverycountrylang.`name`   AS `abweichendLieferungLand`        ,
		billingaddress.`company`     AS `abweichendRechnungFirmenname`   ,
		billingaddress.`firstname`   AS `abweichendRechnungPersVorname`  ,
		billingaddress.`lastname`    AS `abweichendRechnungPersNachname` ,
		billingaddress.`address1`    AS `abweichendRechnungStrasse`      ,
		billingaddress.`postcode`    AS `abweichendRechnungPostleitzahl` ,
		billingaddress.`city`        AS `abweichendRechnungOrt`          ,
		billingcountry.`iso_code`    AS `abweichendRechnungLaendercode`  ,
		billingcountrylang.`name`    AS `abweichendRechnungLand`         ,
		products.`product_id`        AS `Positionsnummer`                ,
		products.`product_reference` AS `ArtikelnummerShop`              ,
		products.`product_reference` AS `Artikelnummer`                  ,
		products.`product_quantity`  AS `Menge`                          ,
		products.`product_price`     AS `abweichenderEinzelpreisNetto`   ,
		products.`tax_rate`          AS `abweichendeMwStProzent`         ,
		products.`product_id`        AS `xProductId`                     ,
		carrier.`name`               AS `Lieferart`                      ,
		billingcountrylang.`name`    AS `Land`                           ,
		billingcountry.`iso_code`    AS `Laendercode`                    ,
		customer.`email`             AS `Email`                          ,
		customer.`id_gender`         AS `PersonAnrede`                   ,
		message.`message`            AS `AnmerkungenBestellung`
	
	FROM `' . _DB_PREFIX_ . 'orders` AS `orders`
	
		INNER JOIN `' . _DB_PREFIX_ . 'order_detail` AS `products`
		ON  (
				orders.`id_order` = products.`id_order`
			)
	
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'address` AS `address`
		ON  (
				orders.`id_address_invoice` = address.`id_address`
			)
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'address` AS `deliveryaddress`
		ON  (
				orders.`id_address_delivery` = deliveryaddress.`id_address`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'country` AS `deliverycountry`
		ON  (
				deliveryaddress.`id_country` = deliverycountry.`id_country`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'country_lang` AS `deliverycountrylang`
		ON  (
				deliveryaddress.`id_country`  = deliverycountrylang.`id_country`
			AND deliverycountrylang.`id_lang` = ' . $id_lang . '
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'address` AS `billingaddress`
		ON  (
				orders.`id_address_invoice` = billingaddress.`id_address`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'country` AS `billingcountry`
		ON  (
				billingaddress.`id_country` = billingcountry.`id_country`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'country_lang` AS `billingcountrylang`
		ON  (
				billingaddress.`id_country`  = billingcountrylang.`id_country`
			AND billingcountrylang.`id_lang` = ' . $id_lang . '
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'carrier` AS carrier
		ON  (
				orders.`id_carrier` = carrier.`id_carrier`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'customer` AS `customer`
		ON  (
				orders.`id_customer` = customer.`id_customer`
			)
			
		LEFT OUTER JOIN `' . _DB_PREFIX_ . 'message` AS `message`
		ON  (
				orders.`id_order` = message.`id_order`
			)
    ';

	return $GLOBALS['datakind'];
}

function row_ueberpruefen($row)
{
    $id_lang = getLanguageId();
    
    if (is_array($row))
	{
        foreach($row as $field => $value)
		{
            $row[$field] = trim(utf8_decode($value));
        }
    }
	
	switch (intval($row['PersonAnrede']))
	{
		case 1:
			$row['PersonAnrede'] = 'Herr';
			break;
		case 2:
			$row['PersonAnrede'] = 'Frau';
			break;
		default:
			$row['PersonAnrede'] = '';
			break;
	}

	$row['Laendercode'] = LaenderkuerzelISO2OMX($row['Laendercode']);	
	$row['abweichendRechnungLaendercode'] = LaenderkuerzelISO2OMX($row['abweichendRechnungLaendercode']);
	$row['abweichendLieferungLaendercode'] = LaenderkuerzelISO2OMX($row['abweichendLieferungLaendercode']);
	
	$row['abweichenderEinzelpreisBrutto'] = round(floatval($row['abweichenderEinzelpreisNetto'] * (1 + $row['abweichendeMwStProzent'] / 100)), 6);

	// get attributes
	$query = '
	SELECT
		product_attribute.`reference` AS Artikelnummer
		
	FROM `' . _DB_PREFIX_ . 'order_detail` AS `products`
	
		INNER JOIN `' . _DB_PREFIX_ . 'product_attribute` AS `product_attribute`
		ON  (
				products.`product_attribute_id` = product_attribute.`id_product_attribute`
			)
			
	WHERE products.`id_order`   = ' . intval($row['orderID']) . '
	AND   products.`product_id` = ' . intval($row['xProductId']) . '
	LIMIT 1';

	$res = mysqli_query($GLOBALS['sql_con'], $query);
	
	if (is_array($attributes = mysqli_fetch_assoc($res)))
	{
		$reference = array_shift($attributes);
		
		$row['Artikelnummer'] = $reference;
	}

	return $row;
}

function artikeldaten_shop_zu_orgamax()
{
	#Querytyp:

	// datakind == 1 => Daten werden als Query verarbeitet
	// datakind == 2 => Daten werden als Array verarbeitet
	
	$GLOBALS['datakind'] = '1';

	#SQL Query f?r Prestashop Artikel

	if ($GLOBALS['attributes_import'])
	{
		$GLOBALS['query'] = '
		SELECT
			products.id_product                AS `productID`               ,
			products.`reference`               AS `ArtikelnummerWebshop`    ,
			products_description.`name`        AS `Artikelbeschreibung`     ,
			products_description.`description` AS `Anmerkungen`             ,
			products.`id_tax`                  AS `MwStCode`                ,
			products.`weight`                  AS `Gewicht`                 ,
			products.`price`                   AS `ArtikelpreisNetto`       ,
			products_attributes.`price`        AS `Var_Preis`               ,
			products_attributes.`weight`       AS `Var_Gewicht`             ,
			products_attributes.`reference`    AS `Var_ArtikelnummerWebshop`,
			products_options.`name`            AS `Var_Wert_Name`           ,
			products_options_values.`name`     AS `Var_Wert`
			
		FROM `' . _DB_PREFIX_ . 'product`                    AS `products`
		
			INNER JOIN `' . _DB_PREFIX_ . 'product_lang`     AS `products_description`
			ON  (
					products.`id_product`          = products_description.`id_product`
				AND products_description.`id_lang` = ' . intval($GLOBALS['articles_language']) . '
				)
				
			LEFT OUTER JOIN `' . _DB_PREFIX_ . 'product_attribute` AS `products_attributes`
			ON  (
					products.`id_product` = products_attributes.`id_product`
				)
				
			LEFT OUTER JOIN `' . _DB_PREFIX_ . 'product_attribute_combination` AS `attribute_combination`
			ON  (
					products_attributes.`id_product_attribute` = attribute_combination.`id_product_attribute`
				)
				
			LEFT OUTER JOIN `' . _DB_PREFIX_ . 'attribute` AS `products_options_common`
			ON  (
					attribute_combination.`id_attribute` = products_options_common.`id_attribute`
				)
				
			LEFT OUTER JOIN `' . _DB_PREFIX_ . 'attribute_lang` AS `products_options_values`
			ON  (
					products_options_common.`id_attribute` = products_options_values.`id_attribute`
				AND products_options_values.`id_lang`      = ' . intval($GLOBALS['articles_language']) . '
				)
				
			LEFT OUTER JOIN `' . _DB_PREFIX_ . 'attribute_group_lang` AS `products_options`
			ON  (
					products_options_common.`id_attribute_group` = products_options.`id_attribute_group`
				AND products_options.`id_lang`                   = ' . intval($GLOBALS['articles_language']) . '
				)
				
		ORDER BY products.`id_product`';
	}
	else
	{
		$GLOBALS['query'] = '
		SELECT
			products.id_product                AS `productID`           ,
			products.`reference`               AS `ArtikelnummerWebshop`,
			products_description.`name`        AS `Artikelbeschreibung` ,
			products_description.`description` AS `Anmerkungen`         ,
			products.`id_tax`                  AS `MwStCode`            ,
			products.`weight`                  AS `Gewicht`             ,
			products.`price`                   AS `ArtikelpreisNetto`   
			
		FROM `' . _DB_PREFIX_ . 'product`                AS `products`
		
			INNER JOIN `' . _DB_PREFIX_ . 'product_lang` AS `products_description`
			ON  (
					products.`id_product`          = products_description.`id_product`
				AND products_description.`id_lang` = ' . intval($GLOBALS['articles_language']) . '
				)
		ORDER BY
			products.`id_product`';
	} // Wenn keine Attribute importiert werden sollen
	
	return $GLOBALS['datakind'];
	
}// artikeldaten_shop_zu_orgamax

function artRow_ueberpruefen($artRow)
{
	$query = '
	SELECT categories_description.name                AS Artikelkategorie
	FROM `' . _DB_PREFIX_ . 'category_product`        AS products_to_categories
	
		INNER JOIN `' . _DB_PREFIX_ . 'category_lang` AS categories_description
		ON  (
				products_to_categories.id_category = categories_description.id_category
			AND categories_description.id_lang     = ' . intval($GLOBALS['articles_language']) . '
			)
			
	WHERE products_to_categories.id_product  = ' . intval($artRow['productID']) . '
	AND   products_to_categories.id_category <> 0';
	
	$qRes = mysqli_query($GLOBALS['sql_con'], $query);
	
	if ($qRes)
	{
		while ($qRow = mysqli_fetch_assoc($qRes))
		{
			$artRow['Artikelkategorie'].= preg_replace('/^[0-9]+\./', '', $qRow['Artikelkategorie']) . ';';
		}
		
		$artRow['Artikelkategorie'] = rtrim($artRow['Artikelkategorie'], ';');
	}
	
	if ($GLOBALS['attributes_import'])
	{
		if ($artRow['Var_Preis'] < 0)
		{
			$artRow['Var_Preis']*= -1;
			$prefixPrice = '-';
		}
		else
		{
			$prefixPrice = '+';
		}
		
		if ($artRow['Var_Gewicht'] < 0)
		{
			$artRow['Var_Gewicht']*= -1;
			$prefixWeight = '-';
		}
		else
		{
			$prefixWeight = '+';
		}
		
		$artRow['Var_Preis_Praefix']   = $prefixPrice;
		$artRow['Var_Gewicht_Praefix'] = $prefixWeight;
		
		if ($artRow['Var_ArtikelnummerWebshop'] <> '') 
		{
			$artRow['ArtikelnummerWebshop'].= $artRow['Var_ArtikelnummerWebshop'];
		}
		
		if (floatval($artRow['Var_Wert']) <> 0) 
		{
			$artRow['Artikelbeschreibung'] .= ' - ' . $artRow['Var_Wert_Name'] . ': ' . $artRow['Var_Wert'];
		}
		
		if (floatval($artRow['Var_Gewicht']) <> 0)
		{
			$artRow['Gewicht'] = sprintf('%d %s %d', $artRow['Gewicht'], $artRow['Var_Gewicht_Praefix'], $artRow['Var_Gewicht']);
		}
		
		if (floatval($artRow['Var_Preis']) <> 0)
		{
			$artRow['ArtikelpreisNetto'] = sprintf('%d %s %d', $artRow['ArtikelpreisNetto'], $artRow['Var_Preis_Praefix'], $artRow['Var_Preis']);
		}
	}
	
	return $artRow;
}

function status_aendern($orderId)
{
	include_once "inc/config.php";
	die(xml_success_ausgeben('This feature is not yet supported.'));
}

function starten()
{
	if (file_exists(ORGAMAX_PS_CONFIG)) {
		include ORGAMAX_PS_CONFIG;
		$GLOBALS['sql_con'] = mysqli_connect(_DB_SERVER_, _DB_USER_, _DB_PASSWD_);
		mysqli_select_db($GLOBALS['sql_con'], _DB_NAME_);
	}
	else {
		die(xml_error_ausgeben($GLOBALS['err_msg']['shop_cfg'],__FILE__, __FUNCTION__, __LINE__));
	}
}

function ende()
{
	mysqli_close($GLOBALS['sql_con']);
}
?>
