<?PHP
/***************************************************************************\
*
*	Copyright (c) 2011 deltra Software GmbH
*	http://www.deltra.de
*
\***************************************************************************/

$webshopList = Shopsystems::getSortedList();

## Testbausteine:
$welcome_text = "Herzlich Willkommen bei dem Einrichtungsassistenten f&uuml;r die Webshop-Schnittstelle zu Ihrer B&uuml;rosoftware. Auf den folgenden Seiten werden Sie durch die einzelnen Einrichtungsschritte geleitet.";
$status_text = "Geben Sie hier bitte an, auf welchen Status Ihre Bestellungen nach erfolgreichen Abrufen gesetzt werden sollen";
$user_agent_text = "Bitte geben Sie an, wie sich Ihre B&uuml;rosoftware beim Abrufen der Bestellungen<br/>authentifizieren soll <i>(Wie in Ihrer Software auch hinterlegt)</i>";
$verschluesseln_text = "Verschl&uuml;sselung aktivieren";
$verschluesseln_schluessel = "Bitte geben Sie hier Ihren Schl&uuml;ssel f&uuml;r die Verschl&uuml;sselung ein <br/><i>(Wie in Ihrer Software auch hinterlegt)</i>";
$openssl_fehlt = "<i>Um die Daten verschl&uuml;sselt &uuml;bergeben zu k&ouml;nnen, ben&ouml;tigen Sie die openSSL Komponente.<br/>
                 Melden Sie sich diesbez&uuml;glich am besten bei Ihrem Webmaster.</i>";
$end_text = "Die Installation wurde erfolgreich beendet.<br/>Sofern Sie die Einrichtung in Ihrer Software bereits 
             abgeschlossen haben, k&ouml;nnen Sie die Shopanbindung nun in Betrieb nehmen.";
$chmod_change = "Hinweis: Sie k&ouml;nnen die Berechtigungen der Datei 'config.php' nun wieder auf 'Nur-Lesen' (CHMOD 444) zur&uuml;ckstellen.";
$config_text = "Hier die E-Commerce-Einstellungen für orgaMAX. F&uuml;gen Sie diese im Men&uuml;punkt<br/><i>Stammdaten -> Einstellungen -> E-Commerce</i> f&uuml;r Ihren Webshop ein.";

// 2010-06-07 - Funktionen Magento Dateireferenz Superklasse Mahe.php
// Linux: Suche Dateireferenz der Superklasse Mage.
function find($dir, $pattern){
	$dir = escapeshellcmd($dir);
	// execute "find" 
	$req = "find $dir -name '$pattern' -print | grep app/Mage.php";
	$files = shell_exec($req);
	$files = explode("\n", trim($files));
	return $files;
}	

// Windows: Suche Dateireferenz der Superklasse Mage.
function dir_rekursiv($verzeichnis) { 
    global $refMage;
    $handle =  opendir($verzeichnis); 
    while ($datei = readdir($handle)) 
    { 
        if ($datei != "." && $datei != "..") 
        { 
            if (is_dir($verzeichnis.$datei))  
            // Verzeichniseintrag gefunden
            { 
                // Aktuelles Verzeichnis auslesen
                dir_rekursiv($verzeichnis.$datei.'/'); 
            }
            else
            {
               if (basename($verzeichnis.$datei) == 'Mage.php') {
                  // Change: 2011-04-18,HM, stristr(...) eingefügt.
                  if ((stristr($verzeichnis.$datei,'app/mage.php')) != false) {
                      // Referenz auf die Super-Klasse Mage
                      $refMage = $verzeichnis.$datei;
                      break;
                  }
                  // [deprecated]
                  // Referenz auf die Super-Klasse Mage
                  #$refMage = $verzeichnis.$datei;
                  #break;
               }
            } 
        }
    } 
    closedir($handle); 
    return $refMage;
}

function getPathFromFile($filename)
{
	if (empty($filename))
		return null;
		
	$level = 0;
	$fileFound = false;
	$path = dirname(__FILE__) . '/../../';	
	
	while(!$fileFound) {
		if(file_exists($path . $filename))
		{
			$fileFound = true;
			break;
		}
		
		if($level > 10)
		{
			return null;
			break;
		}
		
		$level++;
		$path = $path . '../';
	}
    return $path;
}

## Schritt 1:

if (!$_GET['step'])
{
	echo "<form action=\"index.php?step=2\" method=\"post\">";
	echo $welcome_text;
	echo "<br><br>";

	echo "<select id=\"shp_system\" name=\"shp_system\">";
    foreach($webshopList as $shopKey => $shopInfo)
    {
        echo("<option value='$shopKey'>" . $shopInfo['name'] . "</option>");
    }

	echo "</select>";
	echo "<br><br><br><br>";
	//echo "<br><br>";
	echo "<input type=\"submit\" name=\"Submit\" value=\"Weiter\">";
	echo "</form>";
}// Schritt 1

## Schritt 2:
if ($_GET['step']=="2")
{
	echo "<form action=\"index.php?step=3\" method=\"post\">";
	$shp_system = htmlentities($_POST['shp_system']);
    if (!isValidWebshop($shp_system))
    {
        die(DeltraResources::getText("SETUP_SHOPSYSTEM_NOT_VALID"));
    }

	switch ($shp_system)
	{
		case "oscommerce":
			$status_bezeichnung = array("In Bearbeitung", "Versendet");
			$status_wert = array("2","3");
			break;
		case "xtcommerce":
			$status_bezeichnung = array("In Bearbeitung", "Versendet");
			$status_wert = array("2","3");
			break;
		case "gambio":
			$status_bezeichnung = array("In Bearbeitung", "Versendet");
			$status_wert = array("2","3");
			break;
		case "koobi":
			$status_bezeichnung = array("In Bearbeitung", "Ausgef&uuml;hrt");
			$status_wert = array("progress", "ok");
			break;
		case "magento":
			$status_bezeichnung = array("On Hold", "Complete");
			$status_wert = array("'holded'", "'complete'");	
			break;
		case "veyton":
			$status_bezeichnung = array("In Bearbeitung", "Versandt");
			$status_wert = array("17", "33");
			break;
		case "virtuemart":
			$status_bezeichnung = array('In Bearbeitung','Best&auml;tigt', 'Versandt');
			$status_wert = array('1', '2', '5');
			break;
        case "virtuemart2":
            $status_bezeichnung = array('In Bearbeitung','Best&auml;tigt', 'Versandt');
            $status_wert = array('1', '2', '5');
            break;
        case "shopware":
			$status_bezeichnung = array('Offen','In Bearbeitung', 'Komplett abgeschlossen');
			$status_wert = array('0', '1', '2');
            break;
        case "prestashop":
        	$status_bezeichnung = array('In Bearbeitung');
        	$status_wert = array('3');
			break;
        case "xaran":
            $status_bezeichnung = "individuell_keineauswahl";
            break;
		case "individuell":
			$status_bezeichnung = "individuell_keineauswahl";
            break;
        default:
            die(DeltraResources::getText("SETUP_SHOPSYSTEM_NOT_VALID"));
            break;
	}// raussuchen des Shopsystems um entsprechende Statusangaben machen zu können.

	#Liste mit den entsprechenden Einträgen erzeugen:
	#!!! Liste aber nicht für individuelles System anzeigen !!!
	if($status_bezeichnung != "individuell_keineauswahl")
	{
		echo htmlentities($status_text);
		echo "<br>";
		$line_count = count($status_bezeichnung);
		echo "<select id=\"auswahl_status\" name=\"auswahl_status\">";
		for($i = 0; $i < $line_count; $i++)
		{
			echo "<option value=\"$status_wert[$i]\">$status_bezeichnung[$i]</option>";
		}// Für jedes angelegte Shopsystem einen entsprechenden Listenwert generieren
		echo "</select><br><br>";
	}
	else 
	{
		echo "<input type=\"hidden\" name=\"auswahl_status\" value=\"0\">";
	}
	echo $user_agent_text;
	echo "<br>";
	# ShopName wird im Step 3 gebraucht um die Suche nach der Superklasse Mage auf Magento zu beschränken.
	echo "<input type=\"hidden\" name=\"ShopName\" id=\"ShopName\" value=\"$shp_system\">";
	#
	echo "<input type=\"text\" name=\"omx_agent\"><br><br>";
	if (extension_loaded('openssl'))
	{
		echo "<input name=\"checkbox_verschluesselung\" type=\"checkbox\" value=\"checkbox\">";
		echo "&nbsp;&nbsp;&nbsp;";
		echo $verschluesseln_text;
		echo "<br>"; //<br>";
		echo $verschluesseln_schluessel;
		echo "<br>";
		echo "<input type=\"text\" name=\"passkey\"><br><br>";
	}// openssl Komponente gefunden
	else
	{
		echo $openssl_fehlt;
		echo "<br><br>";
	}// openssl nicht gefunden

	echo "<input type=\"submit\" name=\"Submit\" value=\"Weiter\">";
	echo "</form>";
}// Schritt 2

## Schritt 3:
if ($_GET['step']=="3")
{
	$ShopName = htmlentities($_POST['ShopName']);
    $passKey = htmlentities($_POST['passkey']);
    $omxAgent = htmlentities($_POST['omx_agent']);

	# Config Datei öffnen um entsprechende Werte zu editieren...
	$datei = "../inc/config.php";
	$handle = fopen($datei, "r");
	$content = file($datei);
	fclose($handle);
	$handle = fopen($datei, "w");
	fclose($handle);
	fwrite($handle, "");
	$line_count=count($content);
	$handle = fopen($datei, "a");

	# Geb Zeile fuer Zeile den Inhalt der Datei aus
	for($i = 0; $i < $line_count; $i++)
	{
		#Zu ersetzende Strings festlegen:
		$suche_STATUS = "/#change_STATUS/";
		$suche_KEY = "/#change_KEY/";
		$suche_AGENT = "/#change_AGENT/";
		$suche_CRYPT = "/#change_CRYPT/";
		$suche_REF_MAGE = "/#change_REF_MAGE/";
		$suche_ORDER_STATUS = "/#change_DEFAULT_ORDERS_STATUS/";
		$suche_VIRTUEMART_CONFIG = "/#vmConfig/";
		$suche_SHOP_SYSTEM = "/#change_SETUP_SHOP/";

		#Nach Strings suchen:
		preg_match("$suche_STATUS", $content[$i], $status_found);
		preg_match("$suche_KEY", $content[$i], $key_found);
		preg_match("$suche_AGENT", $content[$i], $agent_found);
		preg_match("$suche_CRYPT", $content[$i], $crypt_found);
		preg_match("$suche_REF_MAGE", $content[$i], $refMage_found);
		preg_match("$suche_ORDER_STATUS", $content[$i], $defaultStatus_found);
		preg_match("$suche_VIRTUEMART_CONFIG", $content[$i], $vmConfig_found);
		preg_match("$suche_SHOP_SYSTEM", $content[$i], $shopsystem_found);
		
		if($vmConfig_found)
		{
			if($ShopName == 'virtuemart2' || $ShopName == 'virtuemart')
			{
				$path = getPathFromFile("configuration.php");
				$file = str_replace(dirname(__FILE__), '', $path . "configuration.php");
				$content[$i] = "define('ORGAMAX_VIRTUEMART_CONFIG', '" . $file . "'); //#vmConfig" . "\r\n";
			}
		}
		elseif($defaultStatus_found)
		{
			if($ShopName == 'veyton')
			{
				$content[$i] = '$GLOBALS["DEFAULT_ORDERS_STATUS"] = 16; // #change_DEFAULT_ORDERS_STATUS'. "\r\n";
			}
			else if($ShopName == 'shopware' || $ShopName == 'magento')
			{
				$content[$i] = '$GLOBALS["DEFAULT_ORDERS_STATUS"] = 0; // #change_DEFAULT_ORDERS_STATUS'. "\r\n";
			}
			else
			{
				$content[$i] = '$GLOBALS["DEFAULT_ORDERS_STATUS"] = 1; // #change_DEFAULT_ORDERS_STATUS' . "\r\n";
			}
		}
		elseif ($status_found)
		{
            $auswahlStatus = htmlentities($_POST['auswahl_status']);
            $auswahlStatus = (!is_numeric($auswahlStatus)) ? addslashes($auswahlStatus) : $auswahlStatus;

			$content[$i] = "\t" . '$GLOBALS["aendern_zu"] = ' . stripslashes($auswahlStatus) . ";		// #change_STATUS" . "\r\n";
		}
		elseif ($key_found and isset($_POST['checkbox_verschluesselung']))
		{
			$content[$i] = 'define("SCHLUESSEL", "' . $passKey .'"); // #change_KEY'. "\r\n";
		}
		elseif ($key_found and !isset($_POST['checkbox_verschluesselung']))
		{
			$content[$i] = 'define("SCHLUESSEL", ""); // #change_KEY'. "\r\n";
		}
		elseif ($crypt_found and isset($_POST['checkbox_verschluesselung']))
		{
			$content[$i] = 'define("VERSCHLUESSELN", "'."RIJNDAEL_CBC".'"); // #change_CRYPT'. "\r\n";
		}
		elseif ($crypt_found and !isset($_POST['checkbox_verschluesselung']))
		{
			$content[$i] = 'define("VERSCHLUESSELN", "'."".'"); // #change_CRYPT'. "\r\n";
		}
		elseif ($agent_found)
		{
			$content[$i] = 'define("OMX_AGENT", "' . $omxAgent . '"); // #change_AGENT'. "\r\n";
		}
		elseif ($shopsystem_found)
		{
			$content[$i] = '$GLOBALS["SETUP_SHOP"] = "'.$ShopName.'"; // #change_SETUP_SHOP'. "\r\n";
		}
		elseif ($refMage_found and ($ShopName == "magento"))	//2010-06-07 - Magento Dateireferenz Superklasse Mage.php
		{
			$str = $content[$i];
			$pos1 = strpos($str, ', "') + 3;
			$pos2 = strpos($str, '")');
			$tmpRefMage = substr($str, $pos1, $pos2 - $pos1);
			
			if (!file_exists($tmpRefMage)) {
				//
				if (stristr (PHP_OS, 'Win')) {
				 	// Windows:
					$startSearch = explode("-", strtr($_SERVER["DOCUMENT_ROOT"], "/", "-"));
					$startSearch = $startSearch[0] ."\\". $startSearch[1] ."\\";
                                        #echo $startSearch . "<br>";
					$retMageRef = dir_rekursiv($startSearch);
					$retMageRef = strtr($retMageRef, "/", "\\");
					#echo $retMageRef . "<br>";
					if (!file_exists($retMageRef)) {
						echo "Die Superklasse Mage.php konnte nicht gefunden werden!<br>
						      Bitte wenden Sie sich an Ihren Systemadministrator.<br><br>";
					} else {
						$content[$i] = 'define("REF_MAGE", "'.$retMageRef.'"); // #change_REF_MAGE'. "\n";
					}
				} else { 
					// Linux:
					$startSearch = explode("-", strtr($_SERVER["DOCUMENT_ROOT"], "/", "-"));
					$startSearch = "/" . $startSearch[1];
					$retMageRef = find($startSearch, 'Mage.php');
					#echo $retMageRef[0] ."<br>";
					if (!file_exists($retMageRef[0])) {
						echo "Die Superklasse Mage.php konnte nicht gefunden werden!<br>
						      Bitte wenden Sie sich an Ihren Systemadministrator.<br><br>";
					} else {
						$content[$i] = 'define("REF_MAGE", "'.$retMageRef[0].'"); // #change_REF_MAGE'. "\n";
					}
				}
			} else {
				echo "Die Dateireferenz zur Superklasse Mage.php ist korrekt eingetragen.<br><br>";
			}
		}
		#
		#echo $content[$i] . "<br>";
		#
		fwrite($handle, $content[$i]);
	}// Zeile für Zeile durchgehen und u.U. entsprechende Angaben ersetzen...

	fclose($handle);

	include "summary.php";

	if (!PHP_ERROR && !MYSQL_ERROR)
	{
		$oscDir = basename(realpath(__DIR__."/../.."));
		$protocol = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
		$oscUrl = $protocol.$_SERVER['HTTP_HOST'].'/'.$oscDir.'/';

		echo "<br/>";
		echo $config_text."<br/>";
		echo sprintf("<b>Internetadresse:</b> <input type='text' size='%d' value='%s' readonly/><br/>", strlen($oscUrl), $oscUrl);
		echo sprintf("<b>Identifikationskennung:</b> <input type='text' size='%d' value='%s' readonly/><br/>", strlen($omxAgent), $omxAgent);
		if (isset($_POST['checkbox_verschluesselung']))
			echo sprintf("<b>Passwort:</b> <input type='text' size='%d' value='%s' readonly/><br/>", strlen($passKey), $passKey);
		echo "<br/>";
		echo $end_text;

		if (!chmod("../inc/config.php", 444))
		{
			echo "<br/><br/>";
			echo $chmod_change;
		}
	}

}// Schritt 3

?>